/* Assistant.c generated by valac 0.56.8, the Vala compiler
 * generated from Assistant.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Canonical Ltd
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#define ASSISTANT_CUSTOM_RESPONSE -1
#define ASSISTANT_APPLY 1
#define ASSISTANT_BACK 2
#define ASSISTANT_FORWARD 3
#define ASSISTANT_CANCEL 4
#define ASSISTANT_CLOSE 5
#define ASSISTANT_RESUME 6
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ASSISTANT (assistant_get_type ())
#define ASSISTANT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASSISTANT, Assistant))
#define ASSISTANT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASSISTANT, AssistantClass))
#define IS_ASSISTANT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASSISTANT))
#define IS_ASSISTANT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASSISTANT))
#define ASSISTANT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASSISTANT, AssistantClass))

typedef struct _Assistant Assistant;
typedef struct _AssistantClass AssistantClass;
typedef struct _AssistantPrivate AssistantPrivate;

#define ASSISTANT_TYPE_PAGE_INFO (assistant_page_info_get_type ())
#define ASSISTANT_PAGE_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ASSISTANT_TYPE_PAGE_INFO, AssistantPageInfo))
#define ASSISTANT_PAGE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ASSISTANT_TYPE_PAGE_INFO, AssistantPageInfoClass))
#define ASSISTANT_IS_PAGE_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ASSISTANT_TYPE_PAGE_INFO))
#define ASSISTANT_IS_PAGE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ASSISTANT_TYPE_PAGE_INFO))
#define ASSISTANT_PAGE_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ASSISTANT_TYPE_PAGE_INFO, AssistantPageInfoClass))

typedef struct _AssistantPageInfo AssistantPageInfo;
typedef struct _AssistantPageInfoClass AssistantPageInfoClass;
enum  {
	ASSISTANT_0_PROPERTY,
	ASSISTANT_LAST_OP_WAS_BACK_PROPERTY,
	ASSISTANT_NUM_PROPERTIES
};
static GParamSpec* assistant_properties[ASSISTANT_NUM_PROPERTIES];
typedef enum  {
	ASSISTANT_TYPE_NORMAL,
	ASSISTANT_TYPE_INTERRUPT,
	ASSISTANT_TYPE_CHECK,
	ASSISTANT_TYPE_PROGRESS,
	ASSISTANT_TYPE_FINISH
} AssistantType;

#define ASSISTANT_TYPE_TYPE (assistant_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _AssistantPageInfoPrivate AssistantPageInfoPrivate;
#define _assistant_page_info_unref0(var) ((var == NULL) ? NULL : (var = (assistant_page_info_unref (var), NULL)))

#define TYPE_DEJA_DUP_APP (deja_dup_app_get_type ())
#define DEJA_DUP_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEJA_DUP_APP, DejaDupApp))
#define DEJA_DUP_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEJA_DUP_APP, DejaDupAppClass))
#define IS_DEJA_DUP_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEJA_DUP_APP))
#define IS_DEJA_DUP_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEJA_DUP_APP))
#define DEJA_DUP_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEJA_DUP_APP, DejaDupAppClass))

typedef struct _DejaDupApp DejaDupApp;
typedef struct _DejaDupAppClass DejaDupAppClass;
typedef struct _AssistantParamSpecPageInfo AssistantParamSpecPageInfo;
enum  {
	ASSISTANT_RESPONSE_SIGNAL,
	ASSISTANT_CANCELED_SIGNAL,
	ASSISTANT_CLOSED_SIGNAL,
	ASSISTANT_RESUMED_SIGNAL,
	ASSISTANT_PREPARE_SIGNAL,
	ASSISTANT_FORWARD_SIGNAL,
	ASSISTANT_BACKWARD_SIGNAL,
	ASSISTANT_NUM_SIGNALS
};
static guint assistant_signals[ASSISTANT_NUM_SIGNALS] = {0};

struct _Assistant {
	AdwWindow parent_instance;
	AssistantPrivate * priv;
	gchar* default_title;
	GtkWidget* forward_button;
	GtkStack* page_box;
	gboolean can_resume;
	GList* first_shown;
	GList* current;
};

struct _AssistantClass {
	AdwWindowClass parent_class;
	void (*set_buttons) (Assistant* self);
	guint (*inhibit) (Assistant* self, GtkApplication* app);
};

struct _AssistantPrivate {
	gboolean _last_op_was_back;
	AdwHeaderBar* header_bar;
	GtkWidget* back_button;
	GtkWidget* cancel_button;
	GtkWidget* close_button;
	GtkWidget* resume_button;
	GtkWidget* apply_button;
	guint inhibit_id;
	gboolean interrupt_can_continue;
	gboolean interrupted_from_hidden;
	GList* interrupted;
	GList* infos;
};

struct _AssistantPageInfo {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AssistantPageInfoPrivate * priv;
	GtkWidget* page;
	gchar* title;
	AssistantType type;
	gchar* forward_text;
};

struct _AssistantPageInfoClass {
	GTypeClass parent_class;
	void (*finalize) (AssistantPageInfo *self);
};

struct _AssistantParamSpecPageInfo {
	GParamSpec parent_instance;
};

static gint Assistant_private_offset;
static gpointer assistant_parent_class = NULL;
static gpointer assistant_page_info_parent_class = NULL;

VALA_EXTERN GType assistant_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Assistant, g_object_unref)
VALA_EXTERN gpointer assistant_page_info_ref (gpointer instance);
VALA_EXTERN void assistant_page_info_unref (gpointer instance);
VALA_EXTERN GParamSpec* assistant_param_spec_page_info (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
VALA_EXTERN void assistant_value_set_page_info (GValue* value,
                                    gpointer v_object);
VALA_EXTERN void assistant_value_take_page_info (GValue* value,
                                     gpointer v_object);
VALA_EXTERN gpointer assistant_value_get_page_info (const GValue* value);
VALA_EXTERN GType assistant_page_info_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AssistantPageInfo, assistant_page_info_unref)
VALA_EXTERN void assistant_set_buttons (Assistant* self);
VALA_EXTERN guint assistant_inhibit (Assistant* self,
                         GtkApplication* app);
static void assistant_set_inhibited (Assistant* self,
                              gboolean inhibited);
VALA_EXTERN GType assistant_type_get_type (void) G_GNUC_CONST ;
static void _assistant_page_info_unref0_ (gpointer var);
static inline void _g_list_free__assistant_page_info_unref0_ (GList* self);
VALA_EXTERN void assistant_allow_forward (Assistant* self,
                              gboolean allow);
static void assistant_handle_response (Assistant* self,
                                gint resp);
VALA_EXTERN void assistant_go_back (Assistant* self);
VALA_EXTERN void assistant_go_forward (Assistant* self);
VALA_EXTERN gboolean assistant_is_interrupted (Assistant* self);
VALA_EXTERN void assistant_skip (Assistant* self);
VALA_EXTERN gboolean assistant_get_last_op_was_back (Assistant* self);
VALA_EXTERN gboolean assistant_is_interrupt_type (AssistantType type);
static void assistant_set_last_op_was_back (Assistant* self,
                                     gboolean value);
static void assistant_page_changed (Assistant* self);
VALA_EXTERN void assistant_go_to_page (Assistant* self,
                           GtkWidget* page);
VALA_EXTERN void assistant_interrupt (Assistant* self,
                          GtkWidget* page,
                          gboolean can_continue,
                          gboolean stay_visible);
static void assistant_use_title (Assistant* self,
                          AssistantPageInfo* info);
static void assistant_button_clicked (Assistant* self,
                               GtkButton* button);
VALA_EXTERN GtkButton* assistant_add_button (Assistant* self,
                                 const gchar* label,
                                 gint response_id);
static void _assistant_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
VALA_EXTERN void assistant_make_button_default (Assistant* self,
                                    GtkWidget* button);
static void assistant_real_set_buttons (Assistant* self);
static gboolean assistant_set_first_page (Assistant* self);
VALA_EXTERN void assistant_append_page (Assistant* self,
                            GtkWidget* page,
                            AssistantType type,
                            const gchar* forward_text);
VALA_EXTERN AssistantPageInfo* assistant_page_info_new (void);
VALA_EXTERN AssistantPageInfo* assistant_page_info_construct (GType object_type);
static gboolean _assistant_set_first_page_gsource_func (gpointer self);
VALA_EXTERN void assistant_set_page_title (Assistant* self,
                               GtkWidget* page,
                               const gchar* title);
static guint assistant_real_inhibit (Assistant* self,
                              GtkApplication* app);
VALA_EXTERN GType deja_dup_app_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DejaDupApp, g_object_unref)
VALA_EXTERN DejaDupApp* deja_dup_app_get_instance (void);
VALA_EXTERN Assistant* assistant_new (void);
VALA_EXTERN Assistant* assistant_construct (GType object_type);
static void assistant_page_info_finalize (AssistantPageInfo * obj);
static GType assistant_page_info_get_type_once (void);
static GObject * assistant_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void _assistant_handle_response_assistant_response (Assistant* _sender,
                                                    gint response,
                                                    gpointer self);
static void assistant_finalize (GObject * obj);
static GType assistant_get_type_once (void);
static void _vala_assistant_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_assistant_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
assistant_get_instance_private (Assistant* self)
{
	return G_STRUCT_MEMBER_P (self, Assistant_private_offset);
}

 G_GNUC_NO_INLINE static GType
assistant_type_get_type_once (void)
{
	static const GEnumValue values[] = {{ASSISTANT_TYPE_NORMAL, "ASSISTANT_TYPE_NORMAL", "normal"}, {ASSISTANT_TYPE_INTERRUPT, "ASSISTANT_TYPE_INTERRUPT", "interrupt"}, {ASSISTANT_TYPE_CHECK, "ASSISTANT_TYPE_CHECK", "check"}, {ASSISTANT_TYPE_PROGRESS, "ASSISTANT_TYPE_PROGRESS", "progress"}, {ASSISTANT_TYPE_FINISH, "ASSISTANT_TYPE_FINISH", "finish"}, {0, NULL, NULL}};
	GType assistant_type_type_id;
	assistant_type_type_id = g_enum_register_static ("AssistantType", values);
	return assistant_type_type_id;
}

GType
assistant_type_get_type (void)
{
	static gsize assistant_type_type_id__once = 0;
	if (g_once_init_enter (&assistant_type_type_id__once)) {
		GType assistant_type_type_id;
		assistant_type_type_id = assistant_type_get_type_once ();
		g_once_init_leave (&assistant_type_type_id__once, assistant_type_type_id);
	}
	return assistant_type_type_id__once;
}

static void
_assistant_page_info_unref0_ (gpointer var)
{
#line 58 "../app/Assistant.vala"
	(var == NULL) ? NULL : (var = (assistant_page_info_unref (var), NULL));
#line 279 "Assistant.c"
}

static inline void
_g_list_free__assistant_page_info_unref0_ (GList* self)
{
#line 58 "../app/Assistant.vala"
	g_list_free_full (self, (GDestroyNotify) _assistant_page_info_unref0_);
#line 287 "Assistant.c"
}

void
assistant_allow_forward (Assistant* self,
                         gboolean allow)
{
	gboolean _tmp0_ = FALSE;
	GList* _tmp1_;
#line 100 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 102 "../app/Assistant.vala"
	_tmp1_ = self->current;
#line 102 "../app/Assistant.vala"
	if (_tmp1_ != NULL) {
#line 302 "Assistant.c"
		GtkWidget* _tmp2_;
#line 102 "../app/Assistant.vala"
		_tmp2_ = self->forward_button;
#line 102 "../app/Assistant.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 308 "Assistant.c"
	} else {
#line 102 "../app/Assistant.vala"
		_tmp0_ = FALSE;
#line 312 "Assistant.c"
	}
#line 102 "../app/Assistant.vala"
	if (_tmp0_) {
#line 316 "Assistant.c"
		GtkWidget* _tmp3_;
#line 103 "../app/Assistant.vala"
		_tmp3_ = self->forward_button;
#line 103 "../app/Assistant.vala"
		gtk_widget_set_sensitive (_tmp3_, allow);
#line 322 "Assistant.c"
	}
}

static void
assistant_handle_response (Assistant* self,
                           gint resp)
{
#line 106 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 108 "../app/Assistant.vala"
	switch (resp) {
#line 108 "../app/Assistant.vala"
		case ASSISTANT_BACK:
#line 336 "Assistant.c"
		{
#line 109 "../app/Assistant.vala"
			assistant_go_back (self);
#line 109 "../app/Assistant.vala"
			break;
#line 342 "Assistant.c"
		}
#line 108 "../app/Assistant.vala"
		case ASSISTANT_APPLY:
#line 108 "../app/Assistant.vala"
		case ASSISTANT_FORWARD:
#line 348 "Assistant.c"
		{
#line 111 "../app/Assistant.vala"
			assistant_go_forward (self);
#line 111 "../app/Assistant.vala"
			break;
#line 354 "Assistant.c"
		}
		default:
#line 108 "../app/Assistant.vala"
		case ASSISTANT_CANCEL:
#line 359 "Assistant.c"
		{
#line 113 "../app/Assistant.vala"
			g_signal_emit (self, assistant_signals[ASSISTANT_CANCELED_SIGNAL], 0);
#line 113 "../app/Assistant.vala"
			break;
#line 365 "Assistant.c"
		}
#line 108 "../app/Assistant.vala"
		case ASSISTANT_CLOSE:
#line 369 "Assistant.c"
		{
#line 114 "../app/Assistant.vala"
			g_signal_emit (self, assistant_signals[ASSISTANT_CLOSED_SIGNAL], 0);
#line 114 "../app/Assistant.vala"
			break;
#line 375 "Assistant.c"
		}
#line 108 "../app/Assistant.vala"
		case ASSISTANT_RESUME:
#line 379 "Assistant.c"
		{
#line 115 "../app/Assistant.vala"
			g_signal_emit (self, assistant_signals[ASSISTANT_RESUMED_SIGNAL], 0);
#line 115 "../app/Assistant.vala"
			break;
#line 385 "Assistant.c"
		}
#line 108 "../app/Assistant.vala"
		case ASSISTANT_CUSTOM_RESPONSE:
#line 389 "Assistant.c"
		{
#line 116 "../app/Assistant.vala"
			break;
#line 393 "Assistant.c"
		}
	}
}

gboolean
assistant_is_interrupted (Assistant* self)
{
	GList* _tmp0_;
	gboolean result;
#line 120 "../app/Assistant.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 122 "../app/Assistant.vala"
	_tmp0_ = self->priv->interrupted;
#line 122 "../app/Assistant.vala"
	result = _tmp0_ != NULL;
#line 122 "../app/Assistant.vala"
	return result;
#line 411 "Assistant.c"
}

void
assistant_skip (Assistant* self)
{
	gboolean _tmp0_;
#line 125 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 128 "../app/Assistant.vala"
	_tmp0_ = self->priv->_last_op_was_back;
#line 128 "../app/Assistant.vala"
	if (_tmp0_) {
#line 129 "../app/Assistant.vala"
		assistant_go_back (self);
#line 426 "Assistant.c"
	} else {
#line 131 "../app/Assistant.vala"
		assistant_go_forward (self);
#line 430 "Assistant.c"
	}
}

gboolean
assistant_is_interrupt_type (AssistantType type)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 136 "../app/Assistant.vala"
	if (type == ASSISTANT_TYPE_INTERRUPT) {
#line 136 "../app/Assistant.vala"
		_tmp0_ = TRUE;
#line 443 "Assistant.c"
	} else {
#line 136 "../app/Assistant.vala"
		_tmp0_ = type == ASSISTANT_TYPE_CHECK;
#line 447 "Assistant.c"
	}
#line 136 "../app/Assistant.vala"
	result = _tmp0_;
#line 136 "../app/Assistant.vala"
	return result;
#line 453 "Assistant.c"
}

void
assistant_go_back (Assistant* self)
{
	GList* next = NULL;
	GList* _tmp0_;
	GList* _tmp11_;
#line 139 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 142 "../app/Assistant.vala"
	_tmp0_ = self->priv->interrupted;
#line 142 "../app/Assistant.vala"
	if (_tmp0_ != NULL) {
#line 468 "Assistant.c"
		GList* _tmp1_;
		GList* _tmp2_;
#line 143 "../app/Assistant.vala"
		_tmp1_ = self->priv->interrupted;
#line 143 "../app/Assistant.vala"
		_tmp2_ = _tmp1_->prev;
#line 143 "../app/Assistant.vala"
		next = _tmp2_;
#line 477 "Assistant.c"
	} else {
		GList* _tmp3_;
		GList* _tmp4_;
#line 145 "../app/Assistant.vala"
		_tmp3_ = self->current;
#line 145 "../app/Assistant.vala"
		_tmp4_ = _tmp3_->prev;
#line 145 "../app/Assistant.vala"
		next = _tmp4_;
#line 146 "../app/Assistant.vala"
		while (TRUE) {
#line 489 "Assistant.c"
			gboolean _tmp5_ = FALSE;
			GList* _tmp6_;
			GList* _tmp9_;
			GList* _tmp10_;
#line 146 "../app/Assistant.vala"
			_tmp6_ = next;
#line 146 "../app/Assistant.vala"
			if (_tmp6_ != NULL) {
#line 498 "Assistant.c"
				GList* _tmp7_;
				gconstpointer _tmp8_;
#line 146 "../app/Assistant.vala"
				_tmp7_ = next;
#line 146 "../app/Assistant.vala"
				_tmp8_ = _tmp7_->data;
#line 146 "../app/Assistant.vala"
				_tmp5_ = assistant_is_interrupt_type (((AssistantPageInfo*) _tmp8_)->type);
#line 507 "Assistant.c"
			} else {
#line 146 "../app/Assistant.vala"
				_tmp5_ = FALSE;
#line 511 "Assistant.c"
			}
#line 146 "../app/Assistant.vala"
			if (!_tmp5_) {
#line 146 "../app/Assistant.vala"
				break;
#line 517 "Assistant.c"
			}
#line 147 "../app/Assistant.vala"
			_tmp9_ = next;
#line 147 "../app/Assistant.vala"
			_tmp10_ = _tmp9_->prev;
#line 147 "../app/Assistant.vala"
			next = _tmp10_;
#line 525 "Assistant.c"
		}
	}
#line 150 "../app/Assistant.vala"
	_tmp11_ = next;
#line 150 "../app/Assistant.vala"
	if (_tmp11_ != NULL) {
#line 532 "Assistant.c"
		GList* _tmp12_;
#line 151 "../app/Assistant.vala"
		assistant_set_last_op_was_back (self, TRUE);
#line 152 "../app/Assistant.vala"
		_tmp12_ = next;
#line 152 "../app/Assistant.vala"
		self->current = _tmp12_;
#line 153 "../app/Assistant.vala"
		assistant_page_changed (self);
#line 154 "../app/Assistant.vala"
		g_signal_emit (self, assistant_signals[ASSISTANT_BACKWARD_SIGNAL], 0);
#line 544 "Assistant.c"
	}
}

void
assistant_go_forward (Assistant* self)
{
	GList* next = NULL;
	GList* _tmp0_;
	GList* _tmp13_;
#line 158 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 161 "../app/Assistant.vala"
	_tmp0_ = self->priv->interrupted;
#line 161 "../app/Assistant.vala"
	if (_tmp0_ != NULL) {
#line 560 "Assistant.c"
		GList* _tmp1_;
#line 162 "../app/Assistant.vala"
		_tmp1_ = self->priv->interrupted;
#line 162 "../app/Assistant.vala"
		next = _tmp1_;
#line 163 "../app/Assistant.vala"
		if (self->priv->interrupted_from_hidden) {
#line 164 "../app/Assistant.vala"
			gtk_widget_hide ((GtkWidget*) self);
#line 570 "Assistant.c"
		}
	} else {
		GList* _tmp2_ = NULL;
		GList* _tmp3_;
#line 167 "../app/Assistant.vala"
		_tmp3_ = self->current;
#line 167 "../app/Assistant.vala"
		if (_tmp3_ == NULL) {
#line 579 "Assistant.c"
			GList* _tmp4_;
#line 167 "../app/Assistant.vala"
			_tmp4_ = self->priv->infos;
#line 167 "../app/Assistant.vala"
			_tmp2_ = _tmp4_;
#line 585 "Assistant.c"
		} else {
			GList* _tmp5_;
			GList* _tmp6_;
#line 167 "../app/Assistant.vala"
			_tmp5_ = self->current;
#line 167 "../app/Assistant.vala"
			_tmp6_ = _tmp5_->next;
#line 167 "../app/Assistant.vala"
			_tmp2_ = _tmp6_;
#line 595 "Assistant.c"
		}
#line 167 "../app/Assistant.vala"
		next = _tmp2_;
#line 168 "../app/Assistant.vala"
		while (TRUE) {
#line 601 "Assistant.c"
			gboolean _tmp7_ = FALSE;
			GList* _tmp8_;
			GList* _tmp11_;
			GList* _tmp12_;
#line 168 "../app/Assistant.vala"
			_tmp8_ = next;
#line 168 "../app/Assistant.vala"
			if (_tmp8_ != NULL) {
#line 610 "Assistant.c"
				GList* _tmp9_;
				gconstpointer _tmp10_;
#line 168 "../app/Assistant.vala"
				_tmp9_ = next;
#line 168 "../app/Assistant.vala"
				_tmp10_ = _tmp9_->data;
#line 168 "../app/Assistant.vala"
				_tmp7_ = assistant_is_interrupt_type (((AssistantPageInfo*) _tmp10_)->type);
#line 619 "Assistant.c"
			} else {
#line 168 "../app/Assistant.vala"
				_tmp7_ = FALSE;
#line 623 "Assistant.c"
			}
#line 168 "../app/Assistant.vala"
			if (!_tmp7_) {
#line 168 "../app/Assistant.vala"
				break;
#line 629 "Assistant.c"
			}
#line 169 "../app/Assistant.vala"
			_tmp11_ = next;
#line 169 "../app/Assistant.vala"
			_tmp12_ = _tmp11_->next;
#line 169 "../app/Assistant.vala"
			next = _tmp12_;
#line 637 "Assistant.c"
		}
	}
#line 172 "../app/Assistant.vala"
	_tmp13_ = next;
#line 172 "../app/Assistant.vala"
	if (_tmp13_ != NULL) {
#line 644 "Assistant.c"
		GList* _tmp14_;
#line 173 "../app/Assistant.vala"
		assistant_set_last_op_was_back (self, FALSE);
#line 174 "../app/Assistant.vala"
		_tmp14_ = next;
#line 174 "../app/Assistant.vala"
		self->current = _tmp14_;
#line 175 "../app/Assistant.vala"
		assistant_page_changed (self);
#line 176 "../app/Assistant.vala"
		g_signal_emit (self, assistant_signals[ASSISTANT_FORWARD_SIGNAL], 0);
#line 656 "Assistant.c"
	}
}

void
assistant_go_to_page (Assistant* self,
                      GtkWidget* page)
{
	GList* i = NULL;
	GList* _tmp0_;
#line 180 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 180 "../app/Assistant.vala"
	g_return_if_fail (page != NULL);
#line 182 "../app/Assistant.vala"
	_tmp0_ = self->priv->infos;
#line 182 "../app/Assistant.vala"
	i = _tmp0_;
#line 183 "../app/Assistant.vala"
	while (TRUE) {
#line 676 "Assistant.c"
		GList* _tmp1_;
		GList* _tmp2_;
		gconstpointer _tmp3_;
		GtkWidget* _tmp4_;
		GList* _tmp6_;
		GList* _tmp7_;
#line 183 "../app/Assistant.vala"
		_tmp1_ = i;
#line 183 "../app/Assistant.vala"
		if (!(_tmp1_ != NULL)) {
#line 183 "../app/Assistant.vala"
			break;
#line 689 "Assistant.c"
		}
#line 184 "../app/Assistant.vala"
		_tmp2_ = i;
#line 184 "../app/Assistant.vala"
		_tmp3_ = _tmp2_->data;
#line 184 "../app/Assistant.vala"
		_tmp4_ = ((AssistantPageInfo*) _tmp3_)->page;
#line 184 "../app/Assistant.vala"
		if (_tmp4_ == page) {
#line 699 "Assistant.c"
			GList* _tmp5_;
#line 185 "../app/Assistant.vala"
			_tmp5_ = i;
#line 185 "../app/Assistant.vala"
			self->current = _tmp5_;
#line 186 "../app/Assistant.vala"
			assistant_page_changed (self);
#line 187 "../app/Assistant.vala"
			break;
#line 709 "Assistant.c"
		}
#line 189 "../app/Assistant.vala"
		_tmp6_ = i;
#line 189 "../app/Assistant.vala"
		_tmp7_ = _tmp6_->next;
#line 189 "../app/Assistant.vala"
		i = _tmp7_;
#line 717 "Assistant.c"
	}
}

void
assistant_interrupt (Assistant* self,
                     GtkWidget* page,
                     gboolean can_continue,
                     gboolean stay_visible)
{
	GList* was = NULL;
	GList* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GList* _tmp4_;
#line 193 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 193 "../app/Assistant.vala"
	g_return_if_fail (page != NULL);
#line 195 "../app/Assistant.vala"
	_tmp0_ = self->current;
#line 195 "../app/Assistant.vala"
	was = _tmp0_;
#line 196 "../app/Assistant.vala"
	self->priv->interrupt_can_continue = can_continue;
#line 197 "../app/Assistant.vala"
	assistant_go_to_page (self, page);
#line 198 "../app/Assistant.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 198 "../app/Assistant.vala"
	_tmp3_ = _tmp2_;
#line 198 "../app/Assistant.vala"
	if (!_tmp3_) {
#line 198 "../app/Assistant.vala"
		_tmp1_ = !stay_visible;
#line 753 "Assistant.c"
	} else {
#line 198 "../app/Assistant.vala"
		_tmp1_ = FALSE;
#line 757 "Assistant.c"
	}
#line 198 "../app/Assistant.vala"
	if (_tmp1_) {
#line 199 "../app/Assistant.vala"
		self->priv->interrupted_from_hidden = TRUE;
#line 763 "Assistant.c"
	}
#line 201 "../app/Assistant.vala"
	_tmp4_ = was;
#line 201 "../app/Assistant.vala"
	self->priv->interrupted = _tmp4_;
#line 769 "Assistant.c"
}

static void
assistant_use_title (Assistant* self,
                     AssistantPageInfo* info)
{
	const gchar* _tmp0_;
#line 204 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 204 "../app/Assistant.vala"
	g_return_if_fail (info != NULL);
#line 206 "../app/Assistant.vala"
	_tmp0_ = info->title;
#line 206 "../app/Assistant.vala"
	if (g_strcmp0 (_tmp0_, "") == 0) {
#line 785 "Assistant.c"
		const gchar* _tmp1_;
#line 207 "../app/Assistant.vala"
		_tmp1_ = self->default_title;
#line 207 "../app/Assistant.vala"
		gtk_window_set_title ((GtkWindow*) self, _tmp1_);
#line 791 "Assistant.c"
	} else {
		const gchar* _tmp2_;
#line 209 "../app/Assistant.vala"
		_tmp2_ = info->title;
#line 209 "../app/Assistant.vala"
		gtk_window_set_title ((GtkWindow*) self, _tmp2_);
#line 798 "Assistant.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 233 "../app/Assistant.vala"
	return self ? g_object_ref (self) : NULL;
#line 807 "Assistant.c"
}

static void
assistant_page_changed (Assistant* self)
{
	GList* _tmp0_;
	AssistantPageInfo* info = NULL;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	AssistantPageInfo* _tmp3_;
	GtkWidget* _tmp4_;
	GList* _tmp5_;
	gconstpointer _tmp6_;
	GtkWidget* _tmp7_;
	AssistantPageInfo* _tmp8_;
	GtkWidget* _tmp9_;
#line 212 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 214 "../app/Assistant.vala"
	_tmp0_ = self->current;
#line 214 "../app/Assistant.vala"
	g_return_if_fail (_tmp0_ != NULL);
#line 216 "../app/Assistant.vala"
	self->priv->interrupted = NULL;
#line 217 "../app/Assistant.vala"
	self->priv->interrupted_from_hidden = FALSE;
#line 218 "../app/Assistant.vala"
	_tmp1_ = self->current;
#line 218 "../app/Assistant.vala"
	_tmp2_ = _tmp1_->data;
#line 218 "../app/Assistant.vala"
	info = (AssistantPageInfo*) _tmp2_;
#line 220 "../app/Assistant.vala"
	_tmp3_ = info;
#line 220 "../app/Assistant.vala"
	_tmp4_ = _tmp3_->page;
#line 220 "../app/Assistant.vala"
	g_signal_emit (self, assistant_signals[ASSISTANT_PREPARE_SIGNAL], 0, _tmp4_);
#line 224 "../app/Assistant.vala"
	_tmp5_ = self->current;
#line 224 "../app/Assistant.vala"
	_tmp6_ = _tmp5_->data;
#line 224 "../app/Assistant.vala"
	_tmp7_ = ((AssistantPageInfo*) _tmp6_)->page;
#line 224 "../app/Assistant.vala"
	_tmp8_ = info;
#line 224 "../app/Assistant.vala"
	_tmp9_ = _tmp8_->page;
#line 224 "../app/Assistant.vala"
	if (_tmp7_ == _tmp9_) {
#line 858 "Assistant.c"
		gboolean _tmp10_ = FALSE;
		GList* _tmp11_;
		AssistantPageInfo* _tmp14_;
		AssistantPageInfo* _tmp15_;
		GtkStack* _tmp16_;
		AssistantPageInfo* _tmp17_;
		GtkWidget* _tmp18_;
		GtkWidget* w = NULL;
		GtkWidget* _tmp19_;
		GtkWidget* _tmp20_;
		gboolean _tmp21_ = FALSE;
		GtkWidget* _tmp22_;
#line 225 "../app/Assistant.vala"
		_tmp11_ = self->first_shown;
#line 225 "../app/Assistant.vala"
		if (_tmp11_ == NULL) {
#line 875 "Assistant.c"
			AssistantPageInfo* _tmp12_;
#line 225 "../app/Assistant.vala"
			_tmp12_ = info;
#line 225 "../app/Assistant.vala"
			_tmp10_ = _tmp12_->type != ASSISTANT_TYPE_PROGRESS;
#line 881 "Assistant.c"
		} else {
#line 225 "../app/Assistant.vala"
			_tmp10_ = FALSE;
#line 885 "Assistant.c"
		}
#line 225 "../app/Assistant.vala"
		if (_tmp10_) {
#line 889 "Assistant.c"
			GList* _tmp13_;
#line 226 "../app/Assistant.vala"
			_tmp13_ = self->current;
#line 226 "../app/Assistant.vala"
			self->first_shown = _tmp13_;
#line 895 "Assistant.c"
		}
#line 228 "../app/Assistant.vala"
		_tmp14_ = info;
#line 228 "../app/Assistant.vala"
		assistant_use_title (self, _tmp14_);
#line 229 "../app/Assistant.vala"
		assistant_set_buttons (self);
#line 230 "../app/Assistant.vala"
		_tmp15_ = info;
#line 230 "../app/Assistant.vala"
		assistant_set_inhibited (self, _tmp15_->type == ASSISTANT_TYPE_PROGRESS);
#line 231 "../app/Assistant.vala"
		_tmp16_ = self->page_box;
#line 231 "../app/Assistant.vala"
		_tmp17_ = info;
#line 231 "../app/Assistant.vala"
		_tmp18_ = _tmp17_->page;
#line 231 "../app/Assistant.vala"
		gtk_stack_set_visible_child (_tmp16_, _tmp18_);
#line 233 "../app/Assistant.vala"
		_tmp19_ = gtk_root_get_focus ((GtkRoot*) self);
#line 233 "../app/Assistant.vala"
		_tmp20_ = _g_object_ref0 (_tmp19_);
#line 233 "../app/Assistant.vala"
		w = _tmp20_;
#line 234 "../app/Assistant.vala"
		_tmp22_ = w;
#line 234 "../app/Assistant.vala"
		if (_tmp22_ != NULL) {
#line 925 "Assistant.c"
			GtkWidget* _tmp23_;
#line 234 "../app/Assistant.vala"
			_tmp23_ = w;
#line 234 "../app/Assistant.vala"
			_tmp21_ = G_TYPE_FROM_INSTANCE ((GObject*) _tmp23_) == gtk_label_get_type ();
#line 931 "Assistant.c"
		} else {
#line 234 "../app/Assistant.vala"
			_tmp21_ = FALSE;
#line 935 "Assistant.c"
		}
#line 234 "../app/Assistant.vala"
		if (_tmp21_) {
#line 939 "Assistant.c"
			GtkWidget* _tmp24_;
#line 235 "../app/Assistant.vala"
			_tmp24_ = w;
#line 235 "../app/Assistant.vala"
			gtk_label_select_region (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_label_get_type (), GtkLabel), -1, -1);
#line 945 "Assistant.c"
		}
#line 224 "../app/Assistant.vala"
		_g_object_unref0 (w);
#line 949 "Assistant.c"
	}
}

static void
assistant_button_clicked (Assistant* self,
                          GtkButton* button)
{
	gconstpointer _tmp0_;
#line 238 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 238 "../app/Assistant.vala"
	g_return_if_fail (button != NULL);
#line 240 "../app/Assistant.vala"
	_tmp0_ = g_object_get_data ((GObject*) button, "response-id");
#line 240 "../app/Assistant.vala"
	g_signal_emit (self, assistant_signals[ASSISTANT_RESPONSE_SIGNAL], 0, (gint) ((gintptr) _tmp0_));
#line 966 "Assistant.c"
}

static void
_assistant_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
#line 248 "../app/Assistant.vala"
	assistant_button_clicked ((Assistant*) self, _sender);
#line 975 "Assistant.c"
}

GtkButton*
assistant_add_button (Assistant* self,
                      const gchar* label,
                      gint response_id)
{
	GtkButton* btn = NULL;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* result;
#line 243 "../app/Assistant.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 243 "../app/Assistant.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 245 "../app/Assistant.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_with_mnemonic (label);
#line 245 "../app/Assistant.vala"
	g_object_ref_sink (_tmp0_);
#line 245 "../app/Assistant.vala"
	btn = _tmp0_;
#line 246 "../app/Assistant.vala"
	_tmp1_ = btn;
#line 246 "../app/Assistant.vala"
	gtk_widget_set_receives_default ((GtkWidget*) _tmp1_, TRUE);
#line 247 "../app/Assistant.vala"
	_tmp2_ = btn;
#line 247 "../app/Assistant.vala"
	g_object_set_data_full ((GObject*) _tmp2_, "response-id", (gpointer) ((gintptr) response_id), NULL);
#line 248 "../app/Assistant.vala"
	_tmp3_ = btn;
#line 248 "../app/Assistant.vala"
	g_signal_connect_object (_tmp3_, "clicked", (GCallback) _assistant_button_clicked_gtk_button_clicked, self, 0);
#line 249 "../app/Assistant.vala"
	if (response_id == ASSISTANT_CANCEL) {
#line 1013 "Assistant.c"
		AdwHeaderBar* _tmp4_;
		GtkButton* _tmp5_;
#line 250 "../app/Assistant.vala"
		_tmp4_ = self->priv->header_bar;
#line 250 "../app/Assistant.vala"
		_tmp5_ = btn;
#line 250 "../app/Assistant.vala"
		adw_header_bar_pack_start (_tmp4_, (GtkWidget*) _tmp5_);
#line 1022 "Assistant.c"
	} else {
		AdwHeaderBar* _tmp6_;
		GtkButton* _tmp7_;
#line 252 "../app/Assistant.vala"
		_tmp6_ = self->priv->header_bar;
#line 252 "../app/Assistant.vala"
		_tmp7_ = btn;
#line 252 "../app/Assistant.vala"
		adw_header_bar_pack_end (_tmp6_, (GtkWidget*) _tmp7_);
#line 1032 "Assistant.c"
	}
#line 253 "../app/Assistant.vala"
	result = btn;
#line 253 "../app/Assistant.vala"
	return result;
#line 1038 "Assistant.c"
}

void
assistant_make_button_default (Assistant* self,
                               GtkWidget* button)
{
#line 256 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 256 "../app/Assistant.vala"
	g_return_if_fail (button != NULL);
#line 258 "../app/Assistant.vala"
	gtk_window_set_default_widget ((GtkWindow*) self, button);
#line 259 "../app/Assistant.vala"
	gtk_widget_add_css_class (button, "default");
#line 260 "../app/Assistant.vala"
	gtk_widget_add_css_class (button, "suggested-action");
#line 1055 "Assistant.c"
}

static void
assistant_real_set_buttons (Assistant* self)
{
	GList* _tmp0_;
	AssistantPageInfo* info = NULL;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	gboolean show_cancel = FALSE;
	gboolean show_back = FALSE;
	gboolean show_forward = FALSE;
	gboolean show_close = FALSE;
	gboolean show_resume = FALSE;
	gboolean has_default = FALSE;
	gchar* forward_text = NULL;
	AssistantPageInfo* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	AssistantPageInfo* _tmp6_;
	AdwHeaderBar* area = NULL;
	AdwHeaderBar* _tmp14_;
	AdwHeaderBar* _tmp15_;
	GtkWidget* _tmp16_;
	GtkWidget* _tmp19_;
	GtkWidget* _tmp22_;
	GtkWidget* _tmp25_;
	GtkWidget* _tmp28_;
	GtkWidget* _tmp31_;
#line 265 "../app/Assistant.vala"
	_tmp0_ = self->current;
#line 265 "../app/Assistant.vala"
	g_return_if_fail (_tmp0_ != NULL);
#line 267 "../app/Assistant.vala"
	_tmp1_ = self->current;
#line 267 "../app/Assistant.vala"
	_tmp2_ = _tmp1_->data;
#line 267 "../app/Assistant.vala"
	info = (AssistantPageInfo*) _tmp2_;
#line 269 "../app/Assistant.vala"
	show_cancel = FALSE;
#line 269 "../app/Assistant.vala"
	show_back = FALSE;
#line 269 "../app/Assistant.vala"
	show_forward = FALSE;
#line 270 "../app/Assistant.vala"
	show_close = FALSE;
#line 270 "../app/Assistant.vala"
	show_resume = FALSE;
#line 271 "../app/Assistant.vala"
	has_default = FALSE;
#line 272 "../app/Assistant.vala"
	_tmp3_ = info;
#line 272 "../app/Assistant.vala"
	_tmp4_ = _tmp3_->forward_text;
#line 272 "../app/Assistant.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 272 "../app/Assistant.vala"
	forward_text = _tmp5_;
#line 274 "../app/Assistant.vala"
	_tmp6_ = info;
#line 274 "../app/Assistant.vala"
	switch (_tmp6_->type) {
#line 1119 "Assistant.c"
		default:
#line 274 "../app/Assistant.vala"
		case ASSISTANT_TYPE_NORMAL:
#line 1123 "Assistant.c"
		{
			gboolean _tmp7_ = FALSE;
			GList* _tmp8_;
			GList* _tmp9_;
#line 277 "../app/Assistant.vala"
			show_cancel = TRUE;
#line 278 "../app/Assistant.vala"
			_tmp8_ = self->current;
#line 278 "../app/Assistant.vala"
			_tmp9_ = _tmp8_->prev;
#line 278 "../app/Assistant.vala"
			if (_tmp9_ != NULL) {
#line 1136 "Assistant.c"
				GList* _tmp10_;
				GList* _tmp11_;
#line 278 "../app/Assistant.vala"
				_tmp10_ = self->current;
#line 278 "../app/Assistant.vala"
				_tmp11_ = self->first_shown;
#line 278 "../app/Assistant.vala"
				_tmp7_ = _tmp10_ != _tmp11_;
#line 1145 "Assistant.c"
			} else {
#line 278 "../app/Assistant.vala"
				_tmp7_ = FALSE;
#line 1149 "Assistant.c"
			}
#line 278 "../app/Assistant.vala"
			show_back = _tmp7_;
#line 279 "../app/Assistant.vala"
			show_forward = TRUE;
#line 280 "../app/Assistant.vala"
			break;
#line 1157 "Assistant.c"
		}
#line 274 "../app/Assistant.vala"
		case ASSISTANT_TYPE_INTERRUPT:
#line 1161 "Assistant.c"
		{
#line 282 "../app/Assistant.vala"
			show_cancel = TRUE;
#line 283 "../app/Assistant.vala"
			if (self->priv->interrupt_can_continue) {
#line 1167 "Assistant.c"
				gchar* _tmp12_;
#line 284 "../app/Assistant.vala"
				show_forward = TRUE;
#line 285 "../app/Assistant.vala"
				_tmp12_ = g_strdup (_ ("Co_ntinue"));
#line 285 "../app/Assistant.vala"
				_g_free0 (forward_text);
#line 285 "../app/Assistant.vala"
				forward_text = _tmp12_;
#line 1177 "Assistant.c"
			}
#line 287 "../app/Assistant.vala"
			break;
#line 1181 "Assistant.c"
		}
#line 274 "../app/Assistant.vala"
		case ASSISTANT_TYPE_CHECK:
#line 1185 "Assistant.c"
		{
			gchar* _tmp13_;
#line 289 "../app/Assistant.vala"
			show_cancel = TRUE;
#line 290 "../app/Assistant.vala"
			show_forward = TRUE;
#line 291 "../app/Assistant.vala"
			_tmp13_ = g_strdup (C_ ("verb", "_Test"));
#line 291 "../app/Assistant.vala"
			_g_free0 (forward_text);
#line 291 "../app/Assistant.vala"
			forward_text = _tmp13_;
#line 292 "../app/Assistant.vala"
			break;
#line 1200 "Assistant.c"
		}
#line 274 "../app/Assistant.vala"
		case ASSISTANT_TYPE_PROGRESS:
#line 1204 "Assistant.c"
		{
#line 294 "../app/Assistant.vala"
			show_cancel = TRUE;
#line 295 "../app/Assistant.vala"
			if (self->can_resume) {
#line 296 "../app/Assistant.vala"
				show_resume = TRUE;
#line 1212 "Assistant.c"
			}
#line 297 "../app/Assistant.vala"
			break;
#line 1216 "Assistant.c"
		}
#line 274 "../app/Assistant.vala"
		case ASSISTANT_TYPE_FINISH:
#line 1220 "Assistant.c"
		{
#line 299 "../app/Assistant.vala"
			show_close = TRUE;
#line 300 "../app/Assistant.vala"
			break;
#line 1226 "Assistant.c"
		}
	}
#line 303 "../app/Assistant.vala"
	gtk_window_set_default_widget ((GtkWindow*) self, NULL);
#line 305 "../app/Assistant.vala"
	_tmp14_ = self->priv->header_bar;
#line 305 "../app/Assistant.vala"
	_tmp15_ = _g_object_ref0 (_tmp14_);
#line 305 "../app/Assistant.vala"
	area = _tmp15_;
#line 306 "../app/Assistant.vala"
	_tmp16_ = self->priv->cancel_button;
#line 306 "../app/Assistant.vala"
	if (_tmp16_ != NULL) {
#line 1241 "Assistant.c"
		AdwHeaderBar* _tmp17_;
		GtkWidget* _tmp18_;
#line 307 "../app/Assistant.vala"
		_tmp17_ = area;
#line 307 "../app/Assistant.vala"
		_tmp18_ = self->priv->cancel_button;
#line 307 "../app/Assistant.vala"
		adw_header_bar_remove (_tmp17_, _tmp18_);
#line 307 "../app/Assistant.vala"
		_g_object_unref0 (self->priv->cancel_button);
#line 307 "../app/Assistant.vala"
		self->priv->cancel_button = NULL;
#line 1254 "Assistant.c"
	}
#line 308 "../app/Assistant.vala"
	_tmp19_ = self->priv->close_button;
#line 308 "../app/Assistant.vala"
	if (_tmp19_ != NULL) {
#line 1260 "Assistant.c"
		AdwHeaderBar* _tmp20_;
		GtkWidget* _tmp21_;
#line 309 "../app/Assistant.vala"
		_tmp20_ = area;
#line 309 "../app/Assistant.vala"
		_tmp21_ = self->priv->close_button;
#line 309 "../app/Assistant.vala"
		adw_header_bar_remove (_tmp20_, _tmp21_);
#line 309 "../app/Assistant.vala"
		_g_object_unref0 (self->priv->close_button);
#line 309 "../app/Assistant.vala"
		self->priv->close_button = NULL;
#line 1273 "Assistant.c"
	}
#line 310 "../app/Assistant.vala"
	_tmp22_ = self->priv->back_button;
#line 310 "../app/Assistant.vala"
	if (_tmp22_ != NULL) {
#line 1279 "Assistant.c"
		AdwHeaderBar* _tmp23_;
		GtkWidget* _tmp24_;
#line 311 "../app/Assistant.vala"
		_tmp23_ = area;
#line 311 "../app/Assistant.vala"
		_tmp24_ = self->priv->back_button;
#line 311 "../app/Assistant.vala"
		adw_header_bar_remove (_tmp23_, _tmp24_);
#line 311 "../app/Assistant.vala"
		_g_object_unref0 (self->priv->back_button);
#line 311 "../app/Assistant.vala"
		self->priv->back_button = NULL;
#line 1292 "Assistant.c"
	}
#line 312 "../app/Assistant.vala"
	_tmp25_ = self->priv->resume_button;
#line 312 "../app/Assistant.vala"
	if (_tmp25_ != NULL) {
#line 1298 "Assistant.c"
		AdwHeaderBar* _tmp26_;
		GtkWidget* _tmp27_;
#line 313 "../app/Assistant.vala"
		_tmp26_ = area;
#line 313 "../app/Assistant.vala"
		_tmp27_ = self->priv->resume_button;
#line 313 "../app/Assistant.vala"
		adw_header_bar_remove (_tmp26_, _tmp27_);
#line 313 "../app/Assistant.vala"
		_g_object_unref0 (self->priv->resume_button);
#line 313 "../app/Assistant.vala"
		self->priv->resume_button = NULL;
#line 1311 "Assistant.c"
	}
#line 314 "../app/Assistant.vala"
	_tmp28_ = self->forward_button;
#line 314 "../app/Assistant.vala"
	if (_tmp28_ != NULL) {
#line 1317 "Assistant.c"
		AdwHeaderBar* _tmp29_;
		GtkWidget* _tmp30_;
#line 315 "../app/Assistant.vala"
		_tmp29_ = area;
#line 315 "../app/Assistant.vala"
		_tmp30_ = self->forward_button;
#line 315 "../app/Assistant.vala"
		adw_header_bar_remove (_tmp29_, _tmp30_);
#line 315 "../app/Assistant.vala"
		_g_object_unref0 (self->forward_button);
#line 315 "../app/Assistant.vala"
		self->forward_button = NULL;
#line 1330 "Assistant.c"
	}
#line 316 "../app/Assistant.vala"
	_tmp31_ = self->priv->apply_button;
#line 316 "../app/Assistant.vala"
	if (_tmp31_ != NULL) {
#line 1336 "Assistant.c"
		AdwHeaderBar* _tmp32_;
		GtkWidget* _tmp33_;
#line 317 "../app/Assistant.vala"
		_tmp32_ = area;
#line 317 "../app/Assistant.vala"
		_tmp33_ = self->priv->apply_button;
#line 317 "../app/Assistant.vala"
		adw_header_bar_remove (_tmp32_, _tmp33_);
#line 317 "../app/Assistant.vala"
		_g_object_unref0 (self->priv->apply_button);
#line 317 "../app/Assistant.vala"
		self->priv->apply_button = NULL;
#line 1349 "Assistant.c"
	}
#line 319 "../app/Assistant.vala"
	if (show_forward) {
#line 1353 "Assistant.c"
		AssistantPageInfo* _tmp34_;
		const gchar* _tmp35_;
		GtkButton* _tmp36_;
#line 320 "../app/Assistant.vala"
		_tmp34_ = info;
#line 320 "../app/Assistant.vala"
		_tmp35_ = _tmp34_->forward_text;
#line 320 "../app/Assistant.vala"
		_tmp36_ = assistant_add_button (self, _tmp35_, ASSISTANT_FORWARD);
#line 320 "../app/Assistant.vala"
		_g_object_unref0 (self->forward_button);
#line 320 "../app/Assistant.vala"
		self->forward_button = (GtkWidget*) _tmp36_;
#line 321 "../app/Assistant.vala"
		if (!has_default) {
#line 1369 "Assistant.c"
			GtkWidget* _tmp37_;
#line 322 "../app/Assistant.vala"
			_tmp37_ = self->forward_button;
#line 322 "../app/Assistant.vala"
			assistant_make_button_default (self, _tmp37_);
#line 1375 "Assistant.c"
		}
#line 323 "../app/Assistant.vala"
		has_default = TRUE;
#line 1379 "Assistant.c"
	}
#line 325 "../app/Assistant.vala"
	if (show_resume) {
#line 1383 "Assistant.c"
		GtkButton* _tmp38_;
#line 326 "../app/Assistant.vala"
		_tmp38_ = assistant_add_button (self, _ ("_Resume Later"), ASSISTANT_RESUME);
#line 326 "../app/Assistant.vala"
		_g_object_unref0 (self->priv->resume_button);
#line 326 "../app/Assistant.vala"
		self->priv->resume_button = (GtkWidget*) _tmp38_;
#line 327 "../app/Assistant.vala"
		if (!has_default) {
#line 1393 "Assistant.c"
			GtkWidget* _tmp39_;
#line 328 "../app/Assistant.vala"
			_tmp39_ = self->priv->resume_button;
#line 328 "../app/Assistant.vala"
			assistant_make_button_default (self, _tmp39_);
#line 1399 "Assistant.c"
		}
#line 329 "../app/Assistant.vala"
		has_default = TRUE;
#line 1403 "Assistant.c"
	}
#line 331 "../app/Assistant.vala"
	if (show_back) {
#line 1407 "Assistant.c"
		GtkButton* _tmp40_;
#line 332 "../app/Assistant.vala"
		_tmp40_ = assistant_add_button (self, _ ("_Back"), ASSISTANT_BACK);
#line 332 "../app/Assistant.vala"
		_g_object_unref0 (self->priv->back_button);
#line 332 "../app/Assistant.vala"
		self->priv->back_button = (GtkWidget*) _tmp40_;
#line 1415 "Assistant.c"
	}
#line 333 "../app/Assistant.vala"
	if (show_close) {
#line 1419 "Assistant.c"
		GtkButton* _tmp41_;
#line 334 "../app/Assistant.vala"
		_tmp41_ = assistant_add_button (self, _ ("_Close"), ASSISTANT_CLOSE);
#line 334 "../app/Assistant.vala"
		_g_object_unref0 (self->priv->close_button);
#line 334 "../app/Assistant.vala"
		self->priv->close_button = (GtkWidget*) _tmp41_;
#line 335 "../app/Assistant.vala"
		if (!has_default) {
#line 1429 "Assistant.c"
			GtkWidget* _tmp42_;
#line 336 "../app/Assistant.vala"
			_tmp42_ = self->priv->close_button;
#line 336 "../app/Assistant.vala"
			assistant_make_button_default (self, _tmp42_);
#line 1435 "Assistant.c"
		}
#line 337 "../app/Assistant.vala"
		has_default = TRUE;
#line 1439 "Assistant.c"
	}
#line 339 "../app/Assistant.vala"
	if (show_cancel) {
#line 1443 "Assistant.c"
		GtkButton* _tmp43_;
#line 340 "../app/Assistant.vala"
		_tmp43_ = assistant_add_button (self, _ ("_Cancel"), ASSISTANT_CANCEL);
#line 340 "../app/Assistant.vala"
		_g_object_unref0 (self->priv->cancel_button);
#line 340 "../app/Assistant.vala"
		self->priv->cancel_button = (GtkWidget*) _tmp43_;
#line 1451 "Assistant.c"
	}
#line 263 "../app/Assistant.vala"
	_g_object_unref0 (area);
#line 263 "../app/Assistant.vala"
	_g_free0 (forward_text);
#line 1457 "Assistant.c"
}

void
assistant_set_buttons (Assistant* self)
{
	AssistantClass* _klass_;
#line 263 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 263 "../app/Assistant.vala"
	_klass_ = ASSISTANT_GET_CLASS (self);
#line 263 "../app/Assistant.vala"
	if (_klass_->set_buttons) {
#line 263 "../app/Assistant.vala"
		_klass_->set_buttons (self);
#line 1472 "Assistant.c"
	}
}

static gboolean
assistant_set_first_page (Assistant* self)
{
	gboolean result;
#line 343 "../app/Assistant.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 345 "../app/Assistant.vala"
	self->current = NULL;
#line 346 "../app/Assistant.vala"
	assistant_go_forward (self);
#line 347 "../app/Assistant.vala"
	result = FALSE;
#line 347 "../app/Assistant.vala"
	return result;
#line 1490 "Assistant.c"
}

static gpointer
_assistant_page_info_ref0 (gpointer self)
{
#line 362 "../app/Assistant.vala"
	return self ? assistant_page_info_ref (self) : NULL;
#line 1498 "Assistant.c"
}

static gboolean
_assistant_set_first_page_gsource_func (gpointer self)
{
	gboolean result;
	result = assistant_set_first_page ((Assistant*) self);
#line 367 "../app/Assistant.vala"
	return result;
#line 1508 "Assistant.c"
}

void
assistant_append_page (Assistant* self,
                       GtkWidget* page,
                       AssistantType type,
                       const gchar* forward_text)
{
	gboolean was_empty = FALSE;
	GList* _tmp0_;
	AssistantPageInfo* info = NULL;
	AssistantPageInfo* _tmp1_;
	AssistantPageInfo* _tmp2_;
	GtkWidget* _tmp3_;
	AssistantPageInfo* _tmp4_;
	AssistantPageInfo* _tmp5_;
	gchar* _tmp6_;
	AssistantPageInfo* _tmp7_;
	AssistantPageInfo* _tmp8_;
	GtkStack* _tmp9_;
#line 350 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 350 "../app/Assistant.vala"
	g_return_if_fail (page != NULL);
#line 350 "../app/Assistant.vala"
	g_return_if_fail (forward_text != NULL);
#line 352 "../app/Assistant.vala"
	_tmp0_ = self->priv->infos;
#line 352 "../app/Assistant.vala"
	was_empty = _tmp0_ == NULL;
#line 355 "../app/Assistant.vala"
	gtk_widget_set_hexpand (page, TRUE);
#line 356 "../app/Assistant.vala"
	gtk_widget_set_vexpand (page, TRUE);
#line 358 "../app/Assistant.vala"
	_tmp1_ = assistant_page_info_new ();
#line 358 "../app/Assistant.vala"
	info = _tmp1_;
#line 359 "../app/Assistant.vala"
	_tmp2_ = info;
#line 359 "../app/Assistant.vala"
	_tmp3_ = _g_object_ref0 (page);
#line 359 "../app/Assistant.vala"
	_g_object_unref0 (_tmp2_->page);
#line 359 "../app/Assistant.vala"
	_tmp2_->page = _tmp3_;
#line 360 "../app/Assistant.vala"
	_tmp4_ = info;
#line 360 "../app/Assistant.vala"
	_tmp4_->type = type;
#line 361 "../app/Assistant.vala"
	_tmp5_ = info;
#line 361 "../app/Assistant.vala"
	_tmp6_ = g_strdup (forward_text);
#line 361 "../app/Assistant.vala"
	_g_free0 (_tmp5_->forward_text);
#line 361 "../app/Assistant.vala"
	_tmp5_->forward_text = _tmp6_;
#line 362 "../app/Assistant.vala"
	_tmp7_ = info;
#line 362 "../app/Assistant.vala"
	_tmp8_ = _assistant_page_info_ref0 (_tmp7_);
#line 362 "../app/Assistant.vala"
	self->priv->infos = g_list_append (self->priv->infos, _tmp8_);
#line 364 "../app/Assistant.vala"
	_tmp9_ = self->page_box;
#line 364 "../app/Assistant.vala"
	gtk_stack_add_child (_tmp9_, page);
#line 366 "../app/Assistant.vala"
	if (was_empty) {
#line 367 "../app/Assistant.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _assistant_set_first_page_gsource_func, g_object_ref (self), g_object_unref);
#line 1581 "Assistant.c"
	}
#line 350 "../app/Assistant.vala"
	_assistant_page_info_unref0 (info);
#line 1585 "Assistant.c"
}

void
assistant_set_page_title (Assistant* self,
                          GtkWidget* page,
                          const gchar* title)
{
	GList* _tmp0_;
#line 370 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 370 "../app/Assistant.vala"
	g_return_if_fail (page != NULL);
#line 370 "../app/Assistant.vala"
	g_return_if_fail (title != NULL);
#line 372 "../app/Assistant.vala"
	_tmp0_ = self->priv->infos;
#line 1602 "Assistant.c"
	{
		GList* info_collection = NULL;
		GList* info_it = NULL;
#line 372 "../app/Assistant.vala"
		info_collection = _tmp0_;
#line 372 "../app/Assistant.vala"
		for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
#line 1610 "Assistant.c"
			AssistantPageInfo* _tmp1_;
			AssistantPageInfo* info = NULL;
#line 372 "../app/Assistant.vala"
			_tmp1_ = _assistant_page_info_ref0 ((AssistantPageInfo*) info_it->data);
#line 372 "../app/Assistant.vala"
			info = _tmp1_;
#line 1617 "Assistant.c"
			{
				AssistantPageInfo* _tmp2_;
				GtkWidget* _tmp3_;
#line 373 "../app/Assistant.vala"
				_tmp2_ = info;
#line 373 "../app/Assistant.vala"
				_tmp3_ = _tmp2_->page;
#line 373 "../app/Assistant.vala"
				if (_tmp3_ == page) {
#line 1627 "Assistant.c"
					AssistantPageInfo* _tmp4_;
					gchar* _tmp5_;
					gboolean _tmp6_ = FALSE;
					GList* _tmp7_;
#line 374 "../app/Assistant.vala"
					_tmp4_ = info;
#line 374 "../app/Assistant.vala"
					_tmp5_ = g_strdup (title);
#line 374 "../app/Assistant.vala"
					_g_free0 (_tmp4_->title);
#line 374 "../app/Assistant.vala"
					_tmp4_->title = _tmp5_;
#line 375 "../app/Assistant.vala"
					_tmp7_ = self->current;
#line 375 "../app/Assistant.vala"
					if (_tmp7_ != NULL) {
#line 1644 "Assistant.c"
						GList* _tmp8_;
						gconstpointer _tmp9_;
						GtkWidget* _tmp10_;
#line 375 "../app/Assistant.vala"
						_tmp8_ = self->current;
#line 375 "../app/Assistant.vala"
						_tmp9_ = _tmp8_->data;
#line 375 "../app/Assistant.vala"
						_tmp10_ = ((AssistantPageInfo*) _tmp9_)->page;
#line 375 "../app/Assistant.vala"
						_tmp6_ = _tmp10_ == page;
#line 1656 "Assistant.c"
					} else {
#line 375 "../app/Assistant.vala"
						_tmp6_ = FALSE;
#line 1660 "Assistant.c"
					}
#line 375 "../app/Assistant.vala"
					if (_tmp6_) {
#line 1664 "Assistant.c"
						AssistantPageInfo* _tmp11_;
#line 376 "../app/Assistant.vala"
						_tmp11_ = info;
#line 376 "../app/Assistant.vala"
						assistant_use_title (self, _tmp11_);
#line 1670 "Assistant.c"
					}
#line 377 "../app/Assistant.vala"
					_assistant_page_info_unref0 (info);
#line 377 "../app/Assistant.vala"
					break;
#line 1676 "Assistant.c"
				}
#line 372 "../app/Assistant.vala"
				_assistant_page_info_unref0 (info);
#line 1680 "Assistant.c"
			}
		}
	}
}

static guint
assistant_real_inhibit (Assistant* self,
                        GtkApplication* app)
{
	guint result;
#line 382 "../app/Assistant.vala"
	g_return_val_if_fail (app != NULL, 0U);
#line 384 "../app/Assistant.vala"
	result = (guint) 0;
#line 384 "../app/Assistant.vala"
	return result;
#line 1697 "Assistant.c"
}

guint
assistant_inhibit (Assistant* self,
                   GtkApplication* app)
{
	AssistantClass* _klass_;
#line 382 "../app/Assistant.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 382 "../app/Assistant.vala"
	_klass_ = ASSISTANT_GET_CLASS (self);
#line 382 "../app/Assistant.vala"
	if (_klass_->inhibit) {
#line 382 "../app/Assistant.vala"
		return _klass_->inhibit (self, app);
#line 1713 "Assistant.c"
	}
#line 382 "../app/Assistant.vala"
	return 0U;
#line 1717 "Assistant.c"
}

static void
assistant_set_inhibited (Assistant* self,
                         gboolean inhibited)
{
	DejaDupApp* app = NULL;
	DejaDupApp* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 387 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 389 "../app/Assistant.vala"
	_tmp0_ = deja_dup_app_get_instance ();
#line 389 "../app/Assistant.vala"
	app = _tmp0_;
#line 391 "../app/Assistant.vala"
	if (inhibited) {
#line 391 "../app/Assistant.vala"
		_tmp1_ = self->priv->inhibit_id == ((guint) 0);
#line 1737 "Assistant.c"
	} else {
#line 391 "../app/Assistant.vala"
		_tmp1_ = FALSE;
#line 1741 "Assistant.c"
	}
#line 391 "../app/Assistant.vala"
	if (_tmp1_) {
#line 1745 "Assistant.c"
		DejaDupApp* _tmp2_;
#line 392 "../app/Assistant.vala"
		_tmp2_ = app;
#line 392 "../app/Assistant.vala"
		self->priv->inhibit_id = assistant_inhibit (self, (GtkApplication*) _tmp2_);
#line 1751 "Assistant.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 393 "../app/Assistant.vala"
		if (!inhibited) {
#line 393 "../app/Assistant.vala"
			_tmp3_ = self->priv->inhibit_id > ((guint) 0);
#line 1758 "Assistant.c"
		} else {
#line 393 "../app/Assistant.vala"
			_tmp3_ = FALSE;
#line 1762 "Assistant.c"
		}
#line 393 "../app/Assistant.vala"
		if (_tmp3_) {
#line 1766 "Assistant.c"
			DejaDupApp* _tmp4_;
#line 394 "../app/Assistant.vala"
			_tmp4_ = app;
#line 394 "../app/Assistant.vala"
			gtk_application_uninhibit ((GtkApplication*) _tmp4_, self->priv->inhibit_id);
#line 395 "../app/Assistant.vala"
			self->priv->inhibit_id = (guint) 0;
#line 1774 "Assistant.c"
		}
	}
#line 387 "../app/Assistant.vala"
	_g_object_unref0 (app);
#line 1779 "Assistant.c"
}

Assistant*
assistant_construct (GType object_type)
{
	Assistant * self = NULL;
#line 17 "../app/Assistant.vala"
	self = (Assistant*) g_object_new (object_type, NULL);
#line 17 "../app/Assistant.vala"
	return self;
#line 1790 "Assistant.c"
}

Assistant*
assistant_new (void)
{
#line 17 "../app/Assistant.vala"
	return assistant_construct (TYPE_ASSISTANT);
#line 1798 "Assistant.c"
}

gboolean
assistant_get_last_op_was_back (Assistant* self)
{
	gboolean result;
#line 26 "../app/Assistant.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 26 "../app/Assistant.vala"
	result = self->priv->_last_op_was_back;
#line 26 "../app/Assistant.vala"
	return result;
#line 1811 "Assistant.c"
}

static void
assistant_set_last_op_was_back (Assistant* self,
                                gboolean value)
{
	gboolean old_value;
#line 26 "../app/Assistant.vala"
	g_return_if_fail (self != NULL);
#line 26 "../app/Assistant.vala"
	old_value = assistant_get_last_op_was_back (self);
#line 26 "../app/Assistant.vala"
	if (old_value != value) {
#line 26 "../app/Assistant.vala"
		self->priv->_last_op_was_back = value;
#line 26 "../app/Assistant.vala"
		g_object_notify_by_pspec ((GObject *) self, assistant_properties[ASSISTANT_LAST_OP_WAS_BACK_PROPERTY]);
#line 1829 "Assistant.c"
	}
}

AssistantPageInfo*
assistant_page_info_construct (GType object_type)
{
	AssistantPageInfo* self = NULL;
#line 43 "../app/Assistant.vala"
	self = (AssistantPageInfo*) g_type_create_instance (object_type);
#line 43 "../app/Assistant.vala"
	return self;
#line 1841 "Assistant.c"
}

AssistantPageInfo*
assistant_page_info_new (void)
{
#line 43 "../app/Assistant.vala"
	return assistant_page_info_construct (ASSISTANT_TYPE_PAGE_INFO);
#line 1849 "Assistant.c"
}

static void
assistant_value_page_info_init (GValue* value)
{
#line 43 "../app/Assistant.vala"
	value->data[0].v_pointer = NULL;
#line 1857 "Assistant.c"
}

static void
assistant_value_page_info_free_value (GValue* value)
{
#line 43 "../app/Assistant.vala"
	if (value->data[0].v_pointer) {
#line 43 "../app/Assistant.vala"
		assistant_page_info_unref (value->data[0].v_pointer);
#line 1867 "Assistant.c"
	}
}

static void
assistant_value_page_info_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 43 "../app/Assistant.vala"
	if (src_value->data[0].v_pointer) {
#line 43 "../app/Assistant.vala"
		dest_value->data[0].v_pointer = assistant_page_info_ref (src_value->data[0].v_pointer);
#line 1879 "Assistant.c"
	} else {
#line 43 "../app/Assistant.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1883 "Assistant.c"
	}
}

static gpointer
assistant_value_page_info_peek_pointer (const GValue* value)
{
#line 43 "../app/Assistant.vala"
	return value->data[0].v_pointer;
#line 1892 "Assistant.c"
}

static gchar*
assistant_value_page_info_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 43 "../app/Assistant.vala"
	if (collect_values[0].v_pointer) {
#line 1903 "Assistant.c"
		AssistantPageInfo * object;
		object = collect_values[0].v_pointer;
#line 43 "../app/Assistant.vala"
		if (object->parent_instance.g_class == NULL) {
#line 43 "../app/Assistant.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1910 "Assistant.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 43 "../app/Assistant.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1914 "Assistant.c"
		}
#line 43 "../app/Assistant.vala"
		value->data[0].v_pointer = assistant_page_info_ref (object);
#line 1918 "Assistant.c"
	} else {
#line 43 "../app/Assistant.vala"
		value->data[0].v_pointer = NULL;
#line 1922 "Assistant.c"
	}
#line 43 "../app/Assistant.vala"
	return NULL;
#line 1926 "Assistant.c"
}

static gchar*
assistant_value_page_info_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	AssistantPageInfo ** object_p;
	object_p = collect_values[0].v_pointer;
#line 43 "../app/Assistant.vala"
	if (!object_p) {
#line 43 "../app/Assistant.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1941 "Assistant.c"
	}
#line 43 "../app/Assistant.vala"
	if (!value->data[0].v_pointer) {
#line 43 "../app/Assistant.vala"
		*object_p = NULL;
#line 1947 "Assistant.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 43 "../app/Assistant.vala"
		*object_p = value->data[0].v_pointer;
#line 1951 "Assistant.c"
	} else {
#line 43 "../app/Assistant.vala"
		*object_p = assistant_page_info_ref (value->data[0].v_pointer);
#line 1955 "Assistant.c"
	}
#line 43 "../app/Assistant.vala"
	return NULL;
#line 1959 "Assistant.c"
}

GParamSpec*
assistant_param_spec_page_info (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	AssistantParamSpecPageInfo* spec;
#line 43 "../app/Assistant.vala"
	g_return_val_if_fail (g_type_is_a (object_type, ASSISTANT_TYPE_PAGE_INFO), NULL);
#line 43 "../app/Assistant.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 43 "../app/Assistant.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 43 "../app/Assistant.vala"
	return G_PARAM_SPEC (spec);
#line 1978 "Assistant.c"
}

gpointer
assistant_value_get_page_info (const GValue* value)
{
#line 43 "../app/Assistant.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ASSISTANT_TYPE_PAGE_INFO), NULL);
#line 43 "../app/Assistant.vala"
	return value->data[0].v_pointer;
#line 1988 "Assistant.c"
}

void
assistant_value_set_page_info (GValue* value,
                               gpointer v_object)
{
	AssistantPageInfo * old;
#line 43 "../app/Assistant.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ASSISTANT_TYPE_PAGE_INFO));
#line 43 "../app/Assistant.vala"
	old = value->data[0].v_pointer;
#line 43 "../app/Assistant.vala"
	if (v_object) {
#line 43 "../app/Assistant.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, ASSISTANT_TYPE_PAGE_INFO));
#line 43 "../app/Assistant.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 43 "../app/Assistant.vala"
		value->data[0].v_pointer = v_object;
#line 43 "../app/Assistant.vala"
		assistant_page_info_ref (value->data[0].v_pointer);
#line 2010 "Assistant.c"
	} else {
#line 43 "../app/Assistant.vala"
		value->data[0].v_pointer = NULL;
#line 2014 "Assistant.c"
	}
#line 43 "../app/Assistant.vala"
	if (old) {
#line 43 "../app/Assistant.vala"
		assistant_page_info_unref (old);
#line 2020 "Assistant.c"
	}
}

void
assistant_value_take_page_info (GValue* value,
                                gpointer v_object)
{
	AssistantPageInfo * old;
#line 43 "../app/Assistant.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ASSISTANT_TYPE_PAGE_INFO));
#line 43 "../app/Assistant.vala"
	old = value->data[0].v_pointer;
#line 43 "../app/Assistant.vala"
	if (v_object) {
#line 43 "../app/Assistant.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, ASSISTANT_TYPE_PAGE_INFO));
#line 43 "../app/Assistant.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 43 "../app/Assistant.vala"
		value->data[0].v_pointer = v_object;
#line 2041 "Assistant.c"
	} else {
#line 43 "../app/Assistant.vala"
		value->data[0].v_pointer = NULL;
#line 2045 "Assistant.c"
	}
#line 43 "../app/Assistant.vala"
	if (old) {
#line 43 "../app/Assistant.vala"
		assistant_page_info_unref (old);
#line 2051 "Assistant.c"
	}
}

static void
assistant_page_info_class_init (AssistantPageInfoClass * klass,
                                gpointer klass_data)
{
#line 43 "../app/Assistant.vala"
	assistant_page_info_parent_class = g_type_class_peek_parent (klass);
#line 43 "../app/Assistant.vala"
	((AssistantPageInfoClass *) klass)->finalize = assistant_page_info_finalize;
#line 2063 "Assistant.c"
}

static void
assistant_page_info_instance_init (AssistantPageInfo * self,
                                   gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 45 "../app/Assistant.vala"
	_tmp0_ = g_strdup ("");
#line 45 "../app/Assistant.vala"
	self->title = _tmp0_;
#line 47 "../app/Assistant.vala"
	_tmp1_ = g_strdup ("");
#line 47 "../app/Assistant.vala"
	self->forward_text = _tmp1_;
#line 43 "../app/Assistant.vala"
	self->ref_count = 1;
#line 2082 "Assistant.c"
}

static void
assistant_page_info_finalize (AssistantPageInfo * obj)
{
	AssistantPageInfo * self;
#line 43 "../app/Assistant.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ASSISTANT_TYPE_PAGE_INFO, AssistantPageInfo);
#line 43 "../app/Assistant.vala"
	g_signal_handlers_destroy (self);
#line 44 "../app/Assistant.vala"
	_g_object_unref0 (self->page);
#line 45 "../app/Assistant.vala"
	_g_free0 (self->title);
#line 47 "../app/Assistant.vala"
	_g_free0 (self->forward_text);
#line 2099 "Assistant.c"
}

 G_GNUC_NO_INLINE static GType
assistant_page_info_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { assistant_value_page_info_init, assistant_value_page_info_free_value, assistant_value_page_info_copy_value, assistant_value_page_info_peek_pointer, "p", assistant_value_page_info_collect_value, "p", assistant_value_page_info_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (AssistantPageInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) assistant_page_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AssistantPageInfo), 0, (GInstanceInitFunc) assistant_page_info_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType assistant_page_info_type_id;
	assistant_page_info_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AssistantPageInfo", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return assistant_page_info_type_id;
}

GType
assistant_page_info_get_type (void)
{
	static gsize assistant_page_info_type_id__once = 0;
	if (g_once_init_enter (&assistant_page_info_type_id__once)) {
		GType assistant_page_info_type_id;
		assistant_page_info_type_id = assistant_page_info_get_type_once ();
		g_once_init_leave (&assistant_page_info_type_id__once, assistant_page_info_type_id);
	}
	return assistant_page_info_type_id__once;
}

gpointer
assistant_page_info_ref (gpointer instance)
{
	AssistantPageInfo * self;
	self = instance;
#line 43 "../app/Assistant.vala"
	g_atomic_int_inc (&self->ref_count);
#line 43 "../app/Assistant.vala"
	return instance;
#line 2134 "Assistant.c"
}

void
assistant_page_info_unref (gpointer instance)
{
	AssistantPageInfo * self;
	self = instance;
#line 43 "../app/Assistant.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 43 "../app/Assistant.vala"
		ASSISTANT_PAGE_INFO_GET_CLASS (self)->finalize (self);
#line 43 "../app/Assistant.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2148 "Assistant.c"
	}
}

static void
_assistant_handle_response_assistant_response (Assistant* _sender,
                                               gint response,
                                               gpointer self)
{
#line 89 "../app/Assistant.vala"
	assistant_handle_response ((Assistant*) self, response);
#line 2159 "Assistant.c"
}

static GObject *
assistant_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Assistant * self;
	GtkBox* dialog_box = NULL;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	AdwHeaderBar* _tmp2_;
	AdwHeaderBar* _tmp3_;
	AdwHeaderBar* _tmp4_;
	GtkBox* _tmp5_;
	AdwHeaderBar* _tmp6_;
	GtkStack* _tmp7_;
	GtkStack* _tmp8_;
	GtkStack* _tmp9_;
	GtkBox* _tmp10_;
	GtkStack* _tmp11_;
	DejaDupApp* _tmp12_;
	DejaDupApp* _tmp13_;
#line 68 "../app/Assistant.vala"
	parent_class = G_OBJECT_CLASS (assistant_parent_class);
#line 68 "../app/Assistant.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 68 "../app/Assistant.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASSISTANT, Assistant);
#line 70 "../app/Assistant.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "dialog");
#line 72 "../app/Assistant.vala"
	g_object_set ((GtkWindow*) self, "default-width", 450, NULL);
#line 73 "../app/Assistant.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 74 "../app/Assistant.vala"
	(self->priv->infos == NULL) ? NULL : (self->priv->infos = (_g_list_free__assistant_page_info_unref0_ (self->priv->infos), NULL));
#line 74 "../app/Assistant.vala"
	self->priv->infos = NULL;
#line 76 "../app/Assistant.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 76 "../app/Assistant.vala"
	g_object_ref_sink (_tmp0_);
#line 76 "../app/Assistant.vala"
	dialog_box = _tmp0_;
#line 77 "../app/Assistant.vala"
	_tmp1_ = dialog_box;
#line 77 "../app/Assistant.vala"
	adw_window_set_content ((AdwWindow*) self, (GtkWidget*) _tmp1_);
#line 79 "../app/Assistant.vala"
	_tmp2_ = (AdwHeaderBar*) adw_header_bar_new ();
#line 79 "../app/Assistant.vala"
	g_object_ref_sink (_tmp2_);
#line 79 "../app/Assistant.vala"
	_g_object_unref0 (self->priv->header_bar);
#line 79 "../app/Assistant.vala"
	self->priv->header_bar = _tmp2_;
#line 80 "../app/Assistant.vala"
	_tmp3_ = self->priv->header_bar;
#line 80 "../app/Assistant.vala"
	adw_header_bar_set_show_start_title_buttons (_tmp3_, FALSE);
#line 81 "../app/Assistant.vala"
	_tmp4_ = self->priv->header_bar;
#line 81 "../app/Assistant.vala"
	adw_header_bar_set_show_end_title_buttons (_tmp4_, FALSE);
#line 82 "../app/Assistant.vala"
	_tmp5_ = dialog_box;
#line 82 "../app/Assistant.vala"
	_tmp6_ = self->priv->header_bar;
#line 82 "../app/Assistant.vala"
	gtk_box_append (_tmp5_, (GtkWidget*) _tmp6_);
#line 84 "../app/Assistant.vala"
	_tmp7_ = (GtkStack*) gtk_stack_new ();
#line 84 "../app/Assistant.vala"
	g_object_ref_sink (_tmp7_);
#line 84 "../app/Assistant.vala"
	_g_object_unref0 (self->page_box);
#line 84 "../app/Assistant.vala"
	self->page_box = _tmp7_;
#line 85 "../app/Assistant.vala"
	_tmp8_ = self->page_box;
#line 85 "../app/Assistant.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp8_, TRUE);
#line 86 "../app/Assistant.vala"
	_tmp9_ = self->page_box;
#line 86 "../app/Assistant.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp9_, TRUE);
#line 87 "../app/Assistant.vala"
	_tmp10_ = dialog_box;
#line 87 "../app/Assistant.vala"
	_tmp11_ = self->page_box;
#line 87 "../app/Assistant.vala"
	gtk_box_append (_tmp10_, (GtkWidget*) _tmp11_);
#line 89 "../app/Assistant.vala"
	g_signal_connect_object (self, "response", (GCallback) _assistant_handle_response_assistant_response, self, 0);
#line 91 "../app/Assistant.vala"
	_tmp12_ = deja_dup_app_get_instance ();
#line 91 "../app/Assistant.vala"
	_tmp13_ = _tmp12_;
#line 91 "../app/Assistant.vala"
	gtk_window_set_application ((GtkWindow*) self, (GtkApplication*) _tmp13_);
#line 91 "../app/Assistant.vala"
	_g_object_unref0 (_tmp13_);
#line 68 "../app/Assistant.vala"
	_g_object_unref0 (dialog_box);
#line 68 "../app/Assistant.vala"
	return obj;
#line 2269 "Assistant.c"
}

static void
assistant_class_init (AssistantClass * klass,
                      gpointer klass_data)
{
#line 17 "../app/Assistant.vala"
	assistant_parent_class = g_type_class_peek_parent (klass);
#line 17 "../app/Assistant.vala"
	g_type_class_adjust_private_offset (klass, &Assistant_private_offset);
#line 17 "../app/Assistant.vala"
	((AssistantClass *) klass)->set_buttons = (void (*) (Assistant*)) assistant_real_set_buttons;
#line 17 "../app/Assistant.vala"
	((AssistantClass *) klass)->inhibit = (guint (*) (Assistant*, GtkApplication*)) assistant_real_inhibit;
#line 17 "../app/Assistant.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_assistant_get_property;
#line 17 "../app/Assistant.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_assistant_set_property;
#line 17 "../app/Assistant.vala"
	G_OBJECT_CLASS (klass)->constructor = assistant_constructor;
#line 17 "../app/Assistant.vala"
	G_OBJECT_CLASS (klass)->finalize = assistant_finalize;
#line 17 "../app/Assistant.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASSISTANT_LAST_OP_WAS_BACK_PROPERTY, assistant_properties[ASSISTANT_LAST_OP_WAS_BACK_PROPERTY] = g_param_spec_boolean ("last-op-was-back", "last-op-was-back", "last-op-was-back", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 17 "../app/Assistant.vala"
	assistant_signals[ASSISTANT_RESPONSE_SIGNAL] = g_signal_new ("response", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 17 "../app/Assistant.vala"
	assistant_signals[ASSISTANT_CANCELED_SIGNAL] = g_signal_new ("canceled", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17 "../app/Assistant.vala"
	assistant_signals[ASSISTANT_CLOSED_SIGNAL] = g_signal_new ("closed", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17 "../app/Assistant.vala"
	assistant_signals[ASSISTANT_RESUMED_SIGNAL] = g_signal_new ("resumed", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17 "../app/Assistant.vala"
	assistant_signals[ASSISTANT_PREPARE_SIGNAL] = g_signal_new ("prepare", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_widget_get_type ());
#line 17 "../app/Assistant.vala"
	assistant_signals[ASSISTANT_FORWARD_SIGNAL] = g_signal_new ("forward", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17 "../app/Assistant.vala"
	assistant_signals[ASSISTANT_BACKWARD_SIGNAL] = g_signal_new ("backward", TYPE_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2308 "Assistant.c"
}

static void
assistant_instance_init (Assistant * self,
                         gpointer klass)
{
#line 17 "../app/Assistant.vala"
	self->priv = assistant_get_instance_private (self);
#line 26 "../app/Assistant.vala"
	self->priv->_last_op_was_back = FALSE;
#line 50 "../app/Assistant.vala"
	self->priv->interrupt_can_continue = TRUE;
#line 51 "../app/Assistant.vala"
	self->priv->interrupted_from_hidden = FALSE;
#line 54 "../app/Assistant.vala"
	self->can_resume = FALSE;
#line 56 "../app/Assistant.vala"
	self->first_shown = NULL;
#line 2327 "Assistant.c"
}

static void
assistant_finalize (GObject * obj)
{
	Assistant * self;
#line 17 "../app/Assistant.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASSISTANT, Assistant);
#line 96 "../app/Assistant.vala"
	g_debug ("Assistant.vala:96: Finalizing Assistant\n");
#line 97 "../app/Assistant.vala"
	assistant_set_inhibited (self, FALSE);
#line 32 "../app/Assistant.vala"
	_g_free0 (self->default_title);
#line 33 "../app/Assistant.vala"
	_g_object_unref0 (self->priv->header_bar);
#line 34 "../app/Assistant.vala"
	_g_object_unref0 (self->priv->back_button);
#line 35 "../app/Assistant.vala"
	_g_object_unref0 (self->forward_button);
#line 36 "../app/Assistant.vala"
	_g_object_unref0 (self->priv->cancel_button);
#line 37 "../app/Assistant.vala"
	_g_object_unref0 (self->priv->close_button);
#line 38 "../app/Assistant.vala"
	_g_object_unref0 (self->priv->resume_button);
#line 39 "../app/Assistant.vala"
	_g_object_unref0 (self->priv->apply_button);
#line 40 "../app/Assistant.vala"
	_g_object_unref0 (self->page_box);
#line 58 "../app/Assistant.vala"
	(self->priv->infos == NULL) ? NULL : (self->priv->infos = (_g_list_free__assistant_page_info_unref0_ (self->priv->infos), NULL));
#line 17 "../app/Assistant.vala"
	G_OBJECT_CLASS (assistant_parent_class)->finalize (obj);
#line 2362 "Assistant.c"
}

/**
 * Yes, this is a silly reimplementation of Gtk.Assistant.
 * But Gtk.Assistant has some ridiculous map/unmap logic that resets the page
 * history when unmapped and generally doesn't work when unmapped.  Since
 * continuing to work when hidden is important for us, this is a
 * reimplementation of just the bits we use.
 */
 G_GNUC_NO_INLINE static GType
assistant_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AssistantClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) assistant_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Assistant), 0, (GInstanceInitFunc) assistant_instance_init, NULL };
	GType assistant_type_id;
	assistant_type_id = g_type_register_static (adw_window_get_type (), "Assistant", &g_define_type_info, 0);
	Assistant_private_offset = g_type_add_instance_private (assistant_type_id, sizeof (AssistantPrivate));
	return assistant_type_id;
}

GType
assistant_get_type (void)
{
	static gsize assistant_type_id__once = 0;
	if (g_once_init_enter (&assistant_type_id__once)) {
		GType assistant_type_id;
		assistant_type_id = assistant_get_type_once ();
		g_once_init_leave (&assistant_type_id__once, assistant_type_id);
	}
	return assistant_type_id__once;
}

static void
_vala_assistant_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	Assistant * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ASSISTANT, Assistant);
#line 17 "../app/Assistant.vala"
	switch (property_id) {
#line 17 "../app/Assistant.vala"
		case ASSISTANT_LAST_OP_WAS_BACK_PROPERTY:
#line 17 "../app/Assistant.vala"
		g_value_set_boolean (value, assistant_get_last_op_was_back (self));
#line 17 "../app/Assistant.vala"
		break;
#line 2410 "Assistant.c"
		default:
#line 17 "../app/Assistant.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 17 "../app/Assistant.vala"
		break;
#line 2416 "Assistant.c"
	}
}

static void
_vala_assistant_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	Assistant * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ASSISTANT, Assistant);
#line 17 "../app/Assistant.vala"
	switch (property_id) {
#line 17 "../app/Assistant.vala"
		case ASSISTANT_LAST_OP_WAS_BACK_PROPERTY:
#line 17 "../app/Assistant.vala"
		assistant_set_last_op_was_back (self, g_value_get_boolean (value));
#line 17 "../app/Assistant.vala"
		break;
#line 2436 "Assistant.c"
		default:
#line 17 "../app/Assistant.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 17 "../app/Assistant.vala"
		break;
#line 2442 "Assistant.c"
	}
}

