/* ConfigLocationRow.c generated by valac 0.56.8, the Vala compiler
 * generated from ConfigLocationRow.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <adwaita.h>
#include <glib-object.h>
#include "deja.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CONFIG_LOCATION_ROW (config_location_row_get_type ())
#define CONFIG_LOCATION_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIG_LOCATION_ROW, ConfigLocationRow))
#define CONFIG_LOCATION_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIG_LOCATION_ROW, ConfigLocationRowClass))
#define IS_CONFIG_LOCATION_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIG_LOCATION_ROW))
#define IS_CONFIG_LOCATION_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIG_LOCATION_ROW))
#define CONFIG_LOCATION_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIG_LOCATION_ROW, ConfigLocationRowClass))

typedef struct _ConfigLocationRow ConfigLocationRow;
typedef struct _ConfigLocationRowClass ConfigLocationRowClass;
typedef struct _ConfigLocationRowPrivate ConfigLocationRowPrivate;
enum  {
	CONFIG_LOCATION_ROW_0_PROPERTY,
	CONFIG_LOCATION_ROW_SETTINGS_PROPERTY,
	CONFIG_LOCATION_ROW_DRIVE_SETTINGS_PROPERTY,
	CONFIG_LOCATION_ROW_NUM_PROPERTIES
};
static GParamSpec* config_location_row_properties[CONFIG_LOCATION_ROW_NUM_PROPERTIES];
typedef enum  {
	CONFIG_LOCATION_ROW_GROUP_CLOUD,
	CONFIG_LOCATION_ROW_GROUP_REMOTE,
	CONFIG_LOCATION_ROW_GROUP_VOLUMES,
	CONFIG_LOCATION_ROW_GROUP_LOCAL
} ConfigLocationRowGroup;

#define CONFIG_LOCATION_ROW_TYPE_GROUP (config_location_row_group_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define CONFIG_LOCATION_ROW_TYPE_ITEM (config_location_row_item_get_type ())
#define CONFIG_LOCATION_ROW_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_LOCATION_ROW_TYPE_ITEM, ConfigLocationRowItem))
#define CONFIG_LOCATION_ROW_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_LOCATION_ROW_TYPE_ITEM, ConfigLocationRowItemClass))
#define CONFIG_LOCATION_ROW_IS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_LOCATION_ROW_TYPE_ITEM))
#define CONFIG_LOCATION_ROW_IS_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_LOCATION_ROW_TYPE_ITEM))
#define CONFIG_LOCATION_ROW_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_LOCATION_ROW_TYPE_ITEM, ConfigLocationRowItemClass))

typedef struct _ConfigLocationRowItem ConfigLocationRowItem;
typedef struct _ConfigLocationRowItemClass ConfigLocationRowItemClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ConfigLocationRowItemPrivate ConfigLocationRowItemPrivate;
enum  {
	CONFIG_LOCATION_ROW_ITEM_0_PROPERTY,
	CONFIG_LOCATION_ROW_ITEM_ICON_PROPERTY,
	CONFIG_LOCATION_ROW_ITEM_TEXT_PROPERTY,
	CONFIG_LOCATION_ROW_ITEM_SORT_KEY_PROPERTY,
	CONFIG_LOCATION_ROW_ITEM_ID_PROPERTY,
	CONFIG_LOCATION_ROW_ITEM_PAGE_PROPERTY,
	CONFIG_LOCATION_ROW_ITEM_BACKEND_KIND_PROPERTY,
	CONFIG_LOCATION_ROW_ITEM_NUM_PROPERTIES
};
static GParamSpec* config_location_row_item_properties[CONFIG_LOCATION_ROW_ITEM_NUM_PROPERTIES];

struct _ConfigLocationRow {
	AdwComboRow parent_instance;
	ConfigLocationRowPrivate * priv;
};

struct _ConfigLocationRowClass {
	AdwComboRowClass parent_class;
};

struct _ConfigLocationRowPrivate {
	DejaDupFilteredSettings* _settings;
	DejaDupFilteredSettings* _drive_settings;
	GListStore* store;
};

struct _ConfigLocationRowItem {
	GObject parent_instance;
	ConfigLocationRowItemPrivate * priv;
};

struct _ConfigLocationRowItemClass {
	GObjectClass parent_class;
};

struct _ConfigLocationRowItemPrivate {
	GIcon* _icon;
	gchar* _text;
	gchar* _sort_key;
	gchar* _id;
	gchar* _page;
	DejaDupBackendKind _backend_kind;
};

static gint ConfigLocationRow_private_offset;
static gpointer config_location_row_parent_class = NULL;
static gint ConfigLocationRowItem_private_offset;
static gpointer config_location_row_item_parent_class = NULL;

VALA_EXTERN GType config_location_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConfigLocationRow, g_object_unref)
static GType config_location_row_group_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN void config_location_row_setup (ConfigLocationRow* self,
                                DejaDupFilteredSettings* settings,
                                DejaDupFilteredSettings* drive_settings);
static void config_location_row_set_settings (ConfigLocationRow* self,
                                       DejaDupFilteredSettings* value);
static void config_location_row_set_drive_settings (ConfigLocationRow* self,
                                             DejaDupFilteredSettings* value);
static void config_location_row_add_entry (ConfigLocationRow* self,
                                    const gchar* id,
                                    const gchar* icon,
                                    const gchar* label,
                                    ConfigLocationRowGroup group,
                                    DejaDupBackendKind kind);
static void config_location_row_handle_drive_uuid_change (ConfigLocationRow* self);
static void _config_location_row_handle_drive_uuid_change_g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void config_location_row_add_volume (ConfigLocationRow* self,
                                     GVolumeMonitor* monitor,
                                     GVolume* v);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static guint config_location_row_add_saved_volume (ConfigLocationRow* self);
static void _config_location_row_add_volume_g_volume_monitor_volume_added (GVolumeMonitor* _sender,
                                                                    GVolume* volume,
                                                                    gpointer self);
static void config_location_row_update_volume (ConfigLocationRow* self,
                                        GVolumeMonitor* monitor,
                                        GVolume* v);
static void _config_location_row_update_volume_g_volume_monitor_volume_changed (GVolumeMonitor* _sender,
                                                                         GVolume* volume,
                                                                         gpointer self);
static void config_location_row_remove_volume (ConfigLocationRow* self,
                                        GVolumeMonitor* monitor,
                                        GVolume* v);
static void _config_location_row_remove_volume_g_volume_monitor_volume_removed (GVolumeMonitor* _sender,
                                                                         GVolume* volume,
                                                                         gpointer self);
static gboolean config_location_row_get_mapping (GValue* val,
                                          GVariant* variant,
                                          void* data);
static gboolean _config_location_row_get_mapping_gsettings_bind_get_mapping (GValue* value,
                                                                      GVariant* variant,
                                                                      void* user_data);
static GVariant* config_location_row_set_mapping (GValue* val,
                                           const GVariantType* expected_type,
                                           void* data);
static GVariant* _config_location_row_set_mapping_gsettings_bind_set_mapping (GValue* value,
                                                                       const GVariantType* expected_type,
                                                                       void* user_data);
static void _g_object_unref_gdestroy_notify (void* data);
VALA_EXTERN DejaDupFilteredSettings* config_location_row_get_settings (ConfigLocationRow* self);
static guint config_location_row_add_entry_full (ConfigLocationRow* self,
                                          const gchar* id,
                                          GIcon* icon,
                                          const gchar* label,
                                          ConfigLocationRowGroup group,
                                          const gchar* page,
                                          DejaDupBackendKind backend_kind);
VALA_EXTERN GType config_location_row_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConfigLocationRowItem, g_object_unref)
VALA_EXTERN ConfigLocationRowItem* config_location_row_item_new (GIcon* icon,
                                                     const gchar* text,
                                                     const gchar* sort_key,
                                                     const gchar* id,
                                                     const gchar* page,
                                                     DejaDupBackendKind backend_kind);
VALA_EXTERN ConfigLocationRowItem* config_location_row_item_construct (GType object_type,
                                                           GIcon* icon,
                                                           const gchar* text,
                                                           const gchar* sort_key,
                                                           const gchar* id,
                                                           const gchar* page,
                                                           DejaDupBackendKind backend_kind);
static gint config_location_row_itemcmp (ConfigLocationRowItem* a,
                                  ConfigLocationRowItem* b);
VALA_EXTERN const gchar* config_location_row_item_get_sort_key (ConfigLocationRowItem* self);
static ConfigLocationRowItem* config_location_row_lookup_id (ConfigLocationRow* self,
                                                      const gchar* prefix,
                                                      const gchar* id,
                                                      guint* position);
VALA_EXTERN const gchar* config_location_row_item_get_id (ConfigLocationRowItem* self);
static guint config_location_row_add_volume_full (ConfigLocationRow* self,
                                           const gchar* uuid,
                                           const gchar* name,
                                           GIcon* icon);
static guint config_location_row_update_volume_full (ConfigLocationRow* self,
                                              const gchar* uuid,
                                              const gchar* name,
                                              GIcon* icon);
VALA_EXTERN void config_location_row_item_set_icon (ConfigLocationRowItem* self,
                                        GIcon* value);
VALA_EXTERN void config_location_row_item_set_text (ConfigLocationRowItem* self,
                                        const gchar* value);
static void config_location_row_remove_volume_full (ConfigLocationRow* self,
                                             const gchar* uuid);
VALA_EXTERN DejaDupFilteredSettings* config_location_row_get_drive_settings (ConfigLocationRow* self);
static void config_location_row_set_volume_info (ConfigLocationRow* self,
                                          const gchar* uuid);
VALA_EXTERN ConfigLocationRow* config_location_row_new (void);
VALA_EXTERN ConfigLocationRow* config_location_row_construct (GType object_type);
VALA_EXTERN GIcon* config_location_row_item_get_icon (ConfigLocationRowItem* self);
VALA_EXTERN const gchar* config_location_row_item_get_text (ConfigLocationRowItem* self);
static void config_location_row_item_set_sort_key (ConfigLocationRowItem* self,
                                            const gchar* value);
static void config_location_row_item_set_id (ConfigLocationRowItem* self,
                                      const gchar* value);
VALA_EXTERN const gchar* config_location_row_item_get_page (ConfigLocationRowItem* self);
static void config_location_row_item_set_page (ConfigLocationRowItem* self,
                                        const gchar* value);
VALA_EXTERN DejaDupBackendKind config_location_row_item_get_backend_kind (ConfigLocationRowItem* self);
static void config_location_row_item_set_backend_kind (ConfigLocationRowItem* self,
                                                DejaDupBackendKind value);
static void config_location_row_item_finalize (GObject * obj);
static GType config_location_row_item_get_type_once (void);
static void _vala_config_location_row_item_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_config_location_row_item_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static GObject * config_location_row_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void config_location_row_finalize (GObject * obj);
static GType config_location_row_get_type_once (void);
static void _vala_config_location_row_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_config_location_row_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
config_location_row_get_instance_private (ConfigLocationRow* self)
{
	return G_STRUCT_MEMBER_P (self, ConfigLocationRow_private_offset);
}

 G_GNUC_NO_INLINE static GType
config_location_row_group_get_type_once (void)
{
	static const GEnumValue values[] = {{CONFIG_LOCATION_ROW_GROUP_CLOUD, "CONFIG_LOCATION_ROW_GROUP_CLOUD", "cloud"}, {CONFIG_LOCATION_ROW_GROUP_REMOTE, "CONFIG_LOCATION_ROW_GROUP_REMOTE", "remote"}, {CONFIG_LOCATION_ROW_GROUP_VOLUMES, "CONFIG_LOCATION_ROW_GROUP_VOLUMES", "volumes"}, {CONFIG_LOCATION_ROW_GROUP_LOCAL, "CONFIG_LOCATION_ROW_GROUP_LOCAL", "local"}, {0, NULL, NULL}};
	GType config_location_row_group_type_id;
	config_location_row_group_type_id = g_enum_register_static ("ConfigLocationRowGroup", values);
	return config_location_row_group_type_id;
}

static GType
config_location_row_group_get_type (void)
{
	static gsize config_location_row_group_type_id__once = 0;
	if (g_once_init_enter (&config_location_row_group_type_id__once)) {
		GType config_location_row_group_type_id;
		config_location_row_group_type_id = config_location_row_group_get_type_once ();
		g_once_init_leave (&config_location_row_group_type_id__once, config_location_row_group_type_id);
	}
	return config_location_row_group_type_id__once;
}

static void
_config_location_row_handle_drive_uuid_change_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
#line 74 "../app/ConfigLocationRow.vala"
	config_location_row_handle_drive_uuid_change ((ConfigLocationRow*) self);
#line 300 "ConfigLocationRow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 76 "../app/ConfigLocationRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 308 "ConfigLocationRow.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 76 "../app/ConfigLocationRow.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 316 "ConfigLocationRow.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 76 "../app/ConfigLocationRow.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 324 "ConfigLocationRow.c"
}

static void
_config_location_row_add_volume_g_volume_monitor_volume_added (GVolumeMonitor* _sender,
                                                               GVolume* volume,
                                                               gpointer self)
{
#line 81 "../app/ConfigLocationRow.vala"
	config_location_row_add_volume ((ConfigLocationRow*) self, _sender, volume);
#line 334 "ConfigLocationRow.c"
}

static void
_config_location_row_update_volume_g_volume_monitor_volume_changed (GVolumeMonitor* _sender,
                                                                    GVolume* volume,
                                                                    gpointer self)
{
#line 82 "../app/ConfigLocationRow.vala"
	config_location_row_update_volume ((ConfigLocationRow*) self, _sender, volume);
#line 344 "ConfigLocationRow.c"
}

static void
_config_location_row_remove_volume_g_volume_monitor_volume_removed (GVolumeMonitor* _sender,
                                                                    GVolume* volume,
                                                                    gpointer self)
{
#line 83 "../app/ConfigLocationRow.vala"
	config_location_row_remove_volume ((ConfigLocationRow*) self, _sender, volume);
#line 354 "ConfigLocationRow.c"
}

static gboolean
_config_location_row_get_mapping_gsettings_bind_get_mapping (GValue* value,
                                                             GVariant* variant,
                                                             void* user_data)
{
	gboolean result;
	result = config_location_row_get_mapping (value, variant, user_data);
#line 86 "../app/ConfigLocationRow.vala"
	return result;
#line 366 "ConfigLocationRow.c"
}

static GVariant*
_config_location_row_set_mapping_gsettings_bind_set_mapping (GValue* value,
                                                             const GVariantType* expected_type,
                                                             void* user_data)
{
	GVariant* result;
	result = config_location_row_set_mapping (value, expected_type, user_data);
#line 86 "../app/ConfigLocationRow.vala"
	return result;
#line 378 "ConfigLocationRow.c"
}

static void
_g_object_unref_gdestroy_notify (void* data)
{
#line 86 "../app/ConfigLocationRow.vala"
	g_object_unref (data);
#line 386 "ConfigLocationRow.c"
}

void
config_location_row_setup (ConfigLocationRow* self,
                           DejaDupFilteredSettings* settings,
                           DejaDupFilteredSettings* drive_settings)
{
	gchar* _tmp0_;
	GVolumeMonitor* monitor = NULL;
	GVolumeMonitor* _tmp1_;
	GVolumeMonitor* _tmp2_;
	GList* _tmp3_;
	GVolumeMonitor* _tmp7_;
	GVolumeMonitor* _tmp8_;
	GVolumeMonitor* _tmp9_;
	GObject* _tmp10_;
#line 44 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 44 "../app/ConfigLocationRow.vala"
	g_return_if_fail (settings != NULL);
#line 44 "../app/ConfigLocationRow.vala"
	g_return_if_fail (drive_settings != NULL);
#line 47 "../app/ConfigLocationRow.vala"
	config_location_row_set_settings (self, settings);
#line 48 "../app/ConfigLocationRow.vala"
	config_location_row_set_drive_settings (self, drive_settings);
#line 52 "../app/ConfigLocationRow.vala"
	config_location_row_add_entry (self, "google", "deja-dup-google-drive", _ ("Google Drive"), CONFIG_LOCATION_ROW_GROUP_CLOUD, DEJA_DUP_BACKEND_KIND_GOOGLE);
#line 54 "../app/ConfigLocationRow.vala"
	config_location_row_add_entry (self, "microsoft", "deja-dup-microsoft-onedrive", _ ("Microsoft OneDrive"), CONFIG_LOCATION_ROW_GROUP_CLOUD, DEJA_DUP_BACKEND_KIND_MICROSOFT);
#line 56 "../app/ConfigLocationRow.vala"
	config_location_row_add_entry (self, "local", "folder", _ ("Local Folder"), CONFIG_LOCATION_ROW_GROUP_LOCAL, DEJA_DUP_BACKEND_KIND_LOCAL);
#line 58 "../app/ConfigLocationRow.vala"
	config_location_row_add_entry (self, "remote", "network-server", _ ("Network Server"), CONFIG_LOCATION_ROW_GROUP_REMOTE, DEJA_DUP_BACKEND_KIND_GVFS);
#line 63 "../app/ConfigLocationRow.vala"
	config_location_row_add_entry (self, "gcs", NULL, _ ("Google Cloud Storage"), CONFIG_LOCATION_ROW_GROUP_CLOUD, DEJA_DUP_BACKEND_KIND_UNKNOWN);
#line 65 "../app/ConfigLocationRow.vala"
	config_location_row_add_entry (self, "openstack", NULL, _ ("OpenStack Swift"), CONFIG_LOCATION_ROW_GROUP_CLOUD, DEJA_DUP_BACKEND_KIND_UNKNOWN);
#line 67 "../app/ConfigLocationRow.vala"
	config_location_row_add_entry (self, "rackspace", NULL, _ ("Rackspace Cloud Files"), CONFIG_LOCATION_ROW_GROUP_CLOUD, DEJA_DUP_BACKEND_KIND_UNKNOWN);
#line 69 "../app/ConfigLocationRow.vala"
	config_location_row_add_entry (self, "s3", NULL, _ ("Amazon S3"), CONFIG_LOCATION_ROW_GROUP_CLOUD, DEJA_DUP_BACKEND_KIND_UNKNOWN);
#line 74 "../app/ConfigLocationRow.vala"
	_tmp0_ = g_strconcat ("notify::", DEJA_DUP_DRIVE_UUID_KEY, NULL);
#line 74 "../app/ConfigLocationRow.vala"
	g_signal_connect_object ((GObject*) drive_settings, _tmp0_, (GCallback) _config_location_row_handle_drive_uuid_change_g_object_notify, self, 0);
#line 74 "../app/ConfigLocationRow.vala"
	_g_free0 (_tmp0_);
#line 75 "../app/ConfigLocationRow.vala"
	_tmp1_ = deja_dup_get_volume_monitor ();
#line 75 "../app/ConfigLocationRow.vala"
	monitor = _tmp1_;
#line 76 "../app/ConfigLocationRow.vala"
	_tmp2_ = monitor;
#line 76 "../app/ConfigLocationRow.vala"
	_tmp3_ = g_volume_monitor_get_volumes (_tmp2_);
#line 443 "ConfigLocationRow.c"
	{
		GList* v_collection = NULL;
		GList* v_it = NULL;
#line 76 "../app/ConfigLocationRow.vala"
		v_collection = _tmp3_;
#line 76 "../app/ConfigLocationRow.vala"
		for (v_it = v_collection; v_it != NULL; v_it = v_it->next) {
#line 451 "ConfigLocationRow.c"
			GVolume* _tmp4_;
			GVolume* v = NULL;
#line 76 "../app/ConfigLocationRow.vala"
			_tmp4_ = _g_object_ref0 ((GVolume*) v_it->data);
#line 76 "../app/ConfigLocationRow.vala"
			v = _tmp4_;
#line 458 "ConfigLocationRow.c"
			{
				GVolumeMonitor* _tmp5_;
				GVolume* _tmp6_;
#line 77 "../app/ConfigLocationRow.vala"
				_tmp5_ = monitor;
#line 77 "../app/ConfigLocationRow.vala"
				_tmp6_ = v;
#line 77 "../app/ConfigLocationRow.vala"
				config_location_row_add_volume (self, _tmp5_, _tmp6_);
#line 76 "../app/ConfigLocationRow.vala"
				_g_object_unref0 (v);
#line 470 "ConfigLocationRow.c"
			}
		}
#line 76 "../app/ConfigLocationRow.vala"
		(v_collection == NULL) ? NULL : (v_collection = (_g_list_free__g_object_unref0_ (v_collection), NULL));
#line 475 "ConfigLocationRow.c"
	}
#line 79 "../app/ConfigLocationRow.vala"
	config_location_row_add_saved_volume (self);
#line 81 "../app/ConfigLocationRow.vala"
	_tmp7_ = monitor;
#line 81 "../app/ConfigLocationRow.vala"
	g_signal_connect_object (_tmp7_, "volume-added", (GCallback) _config_location_row_add_volume_g_volume_monitor_volume_added, self, 0);
#line 82 "../app/ConfigLocationRow.vala"
	_tmp8_ = monitor;
#line 82 "../app/ConfigLocationRow.vala"
	g_signal_connect_object (_tmp8_, "volume-changed", (GCallback) _config_location_row_update_volume_g_volume_monitor_volume_changed, self, 0);
#line 83 "../app/ConfigLocationRow.vala"
	_tmp9_ = monitor;
#line 83 "../app/ConfigLocationRow.vala"
	g_signal_connect_object (_tmp9_, "volume-removed", (GCallback) _config_location_row_remove_volume_g_volume_monitor_volume_removed, self, 0);
#line 86 "../app/ConfigLocationRow.vala"
	_tmp10_ = g_object_ref ((GObject*) self);
#line 86 "../app/ConfigLocationRow.vala"
	g_settings_bind_with_mapping ((GSettings*) settings, DEJA_DUP_BACKEND_KEY, (GObject*) self, "selected", G_SETTINGS_BIND_DEFAULT, _config_location_row_get_mapping_gsettings_bind_get_mapping, _config_location_row_set_mapping_gsettings_bind_set_mapping, _tmp10_, _g_object_unref_gdestroy_notify);
#line 44 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (monitor);
#line 497 "ConfigLocationRow.c"
}

static void
config_location_row_add_entry (ConfigLocationRow* self,
                               const gchar* id,
                               const gchar* icon,
                               const gchar* label,
                               ConfigLocationRowGroup group,
                               DejaDupBackendKind kind)
{
	gchar* backend_key = NULL;
	DejaDupFilteredSettings* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	GThemedIcon* _tmp6_ = NULL;
#line 93 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 93 "../app/ConfigLocationRow.vala"
	g_return_if_fail (id != NULL);
#line 93 "../app/ConfigLocationRow.vala"
	g_return_if_fail (label != NULL);
#line 96 "../app/ConfigLocationRow.vala"
	_tmp0_ = self->priv->_settings;
#line 96 "../app/ConfigLocationRow.vala"
	_tmp1_ = deja_dup_backend_get_key_name ((GSettings*) _tmp0_);
#line 96 "../app/ConfigLocationRow.vala"
	backend_key = _tmp1_;
#line 97 "../app/ConfigLocationRow.vala"
	_tmp3_ = backend_key;
#line 97 "../app/ConfigLocationRow.vala"
	if (g_strcmp0 (_tmp3_, id) != 0) {
#line 530 "ConfigLocationRow.c"
		DejaDupToolPlugin* _tmp4_;
		DejaDupToolPlugin* _tmp5_;
#line 97 "../app/ConfigLocationRow.vala"
		_tmp4_ = deja_dup_get_tool ();
#line 97 "../app/ConfigLocationRow.vala"
		_tmp5_ = _tmp4_;
#line 97 "../app/ConfigLocationRow.vala"
		_tmp2_ = !deja_dup_tool_plugin_supports_backend (_tmp5_, kind, NULL);
#line 97 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (_tmp5_);
#line 541 "ConfigLocationRow.c"
	} else {
#line 97 "../app/ConfigLocationRow.vala"
		_tmp2_ = FALSE;
#line 545 "ConfigLocationRow.c"
	}
#line 97 "../app/ConfigLocationRow.vala"
	if (_tmp2_) {
#line 98 "../app/ConfigLocationRow.vala"
		_g_free0 (backend_key);
#line 98 "../app/ConfigLocationRow.vala"
		return;
#line 553 "ConfigLocationRow.c"
	}
#line 100 "../app/ConfigLocationRow.vala"
	if (icon == NULL) {
#line 100 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (_tmp6_);
#line 100 "../app/ConfigLocationRow.vala"
		_tmp6_ = NULL;
#line 561 "ConfigLocationRow.c"
	} else {
		GThemedIcon* _tmp7_;
#line 100 "../app/ConfigLocationRow.vala"
		_tmp7_ = (GThemedIcon*) g_themed_icon_new (icon);
#line 100 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (_tmp6_);
#line 100 "../app/ConfigLocationRow.vala"
		_tmp6_ = _tmp7_;
#line 570 "ConfigLocationRow.c"
	}
#line 100 "../app/ConfigLocationRow.vala"
	config_location_row_add_entry_full (self, id, (GIcon*) _tmp6_, label, group, NULL, kind);
#line 93 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (_tmp6_);
#line 93 "../app/ConfigLocationRow.vala"
	_g_free0 (backend_key);
#line 578 "ConfigLocationRow.c"
}

static guint
config_location_row_add_entry_full (ConfigLocationRow* self,
                                    const gchar* id,
                                    GIcon* icon,
                                    const gchar* label,
                                    ConfigLocationRowGroup group,
                                    const gchar* page,
                                    DejaDupBackendKind backend_kind)
{
	const gchar* _tmp0_ = NULL;
	gchar* calculated_page = NULL;
	gchar* _tmp1_;
	gchar* sort_key = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	ConfigLocationRowItem* item = NULL;
	ConfigLocationRowItem* _tmp8_;
	GListStore* _tmp9_;
	guint result;
#line 103 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 103 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (id != NULL, 0U);
#line 103 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (label != NULL, 0U);
#line 106 "../app/ConfigLocationRow.vala"
	if (page == NULL) {
#line 106 "../app/ConfigLocationRow.vala"
		_tmp0_ = id;
#line 614 "ConfigLocationRow.c"
	} else {
#line 106 "../app/ConfigLocationRow.vala"
		_tmp0_ = page;
#line 618 "ConfigLocationRow.c"
	}
#line 106 "../app/ConfigLocationRow.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 106 "../app/ConfigLocationRow.vala"
	calculated_page = _tmp1_;
#line 107 "../app/ConfigLocationRow.vala"
	_tmp2_ = g_utf8_casefold (label, (gssize) -1);
#line 107 "../app/ConfigLocationRow.vala"
	_tmp3_ = _tmp2_;
#line 107 "../app/ConfigLocationRow.vala"
	_tmp4_ = g_utf8_collate_key (_tmp3_, (gssize) -1);
#line 107 "../app/ConfigLocationRow.vala"
	_tmp5_ = _tmp4_;
#line 107 "../app/ConfigLocationRow.vala"
	_tmp6_ = g_strdup_printf ("%d%s", (gint) group, _tmp5_);
#line 107 "../app/ConfigLocationRow.vala"
	_tmp7_ = _tmp6_;
#line 107 "../app/ConfigLocationRow.vala"
	_g_free0 (_tmp5_);
#line 107 "../app/ConfigLocationRow.vala"
	_g_free0 (_tmp3_);
#line 107 "../app/ConfigLocationRow.vala"
	sort_key = _tmp7_;
#line 108 "../app/ConfigLocationRow.vala"
	_tmp8_ = config_location_row_item_new (icon, label, sort_key, id, calculated_page, backend_kind);
#line 108 "../app/ConfigLocationRow.vala"
	item = _tmp8_;
#line 109 "../app/ConfigLocationRow.vala"
	_tmp9_ = self->priv->store;
#line 109 "../app/ConfigLocationRow.vala"
	result = g_list_store_insert_sorted (_tmp9_, (GObject*) item, (GCompareDataFunc) config_location_row_itemcmp, NULL);
#line 109 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (item);
#line 109 "../app/ConfigLocationRow.vala"
	_g_free0 (sort_key);
#line 109 "../app/ConfigLocationRow.vala"
	_g_free0 (calculated_page);
#line 109 "../app/ConfigLocationRow.vala"
	return result;
#line 658 "ConfigLocationRow.c"
}

static gint
config_location_row_itemcmp (ConfigLocationRowItem* a,
                             ConfigLocationRowItem* b)
{
	GCompareFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint result;
#line 112 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 112 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 113 "../app/ConfigLocationRow.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 113 "../app/ConfigLocationRow.vala"
	_tmp1_ = config_location_row_item_get_sort_key (a);
#line 113 "../app/ConfigLocationRow.vala"
	_tmp2_ = _tmp1_;
#line 113 "../app/ConfigLocationRow.vala"
	_tmp3_ = config_location_row_item_get_sort_key (b);
#line 113 "../app/ConfigLocationRow.vala"
	_tmp4_ = _tmp3_;
#line 113 "../app/ConfigLocationRow.vala"
	result = _tmp0_ (_tmp2_, _tmp4_);
#line 113 "../app/ConfigLocationRow.vala"
	return result;
#line 689 "ConfigLocationRow.c"
}

static ConfigLocationRowItem*
config_location_row_lookup_id (ConfigLocationRow* self,
                               const gchar* prefix,
                               const gchar* id,
                               guint* position)
{
	guint _vala_position = 0U;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gchar* full_id = NULL;
	gchar* _tmp6_;
	ConfigLocationRowItem* result;
#line 117 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 119 "../app/ConfigLocationRow.vala"
	_vala_position = G_MAXUINT;
#line 120 "../app/ConfigLocationRow.vala"
	if (prefix != NULL) {
#line 120 "../app/ConfigLocationRow.vala"
		_tmp1_ = id != NULL;
#line 712 "ConfigLocationRow.c"
	} else {
#line 120 "../app/ConfigLocationRow.vala"
		_tmp1_ = FALSE;
#line 716 "ConfigLocationRow.c"
	}
#line 120 "../app/ConfigLocationRow.vala"
	if (_tmp1_) {
#line 720 "ConfigLocationRow.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 120 "../app/ConfigLocationRow.vala"
		_tmp2_ = g_strconcat (prefix, ":", NULL);
#line 120 "../app/ConfigLocationRow.vala"
		_tmp3_ = _tmp2_;
#line 120 "../app/ConfigLocationRow.vala"
		_tmp4_ = g_strconcat (_tmp3_, id, NULL);
#line 120 "../app/ConfigLocationRow.vala"
		_g_free0 (_tmp0_);
#line 120 "../app/ConfigLocationRow.vala"
		_tmp0_ = _tmp4_;
#line 120 "../app/ConfigLocationRow.vala"
		_g_free0 (_tmp3_);
#line 736 "ConfigLocationRow.c"
	} else {
		gchar* _tmp5_;
#line 120 "../app/ConfigLocationRow.vala"
		_tmp5_ = g_strdup (id);
#line 120 "../app/ConfigLocationRow.vala"
		_g_free0 (_tmp0_);
#line 120 "../app/ConfigLocationRow.vala"
		_tmp0_ = _tmp5_;
#line 745 "ConfigLocationRow.c"
	}
#line 120 "../app/ConfigLocationRow.vala"
	_tmp6_ = g_strdup (_tmp0_);
#line 120 "../app/ConfigLocationRow.vala"
	full_id = _tmp6_;
#line 751 "ConfigLocationRow.c"
	{
		guint i = 0U;
#line 122 "../app/ConfigLocationRow.vala"
		i = (guint) 0;
#line 756 "ConfigLocationRow.c"
		{
			gboolean _tmp7_ = FALSE;
#line 122 "../app/ConfigLocationRow.vala"
			_tmp7_ = TRUE;
#line 122 "../app/ConfigLocationRow.vala"
			while (TRUE) {
#line 763 "ConfigLocationRow.c"
				GListStore* _tmp9_;
				ConfigLocationRowItem* item = NULL;
				GListStore* _tmp10_;
				GObject* _tmp11_;
				gboolean _tmp12_ = FALSE;
				const gchar* _tmp13_;
#line 122 "../app/ConfigLocationRow.vala"
				if (!_tmp7_) {
#line 772 "ConfigLocationRow.c"
					guint _tmp8_;
#line 122 "../app/ConfigLocationRow.vala"
					_tmp8_ = i;
#line 122 "../app/ConfigLocationRow.vala"
					i = _tmp8_ + 1;
#line 778 "ConfigLocationRow.c"
				}
#line 122 "../app/ConfigLocationRow.vala"
				_tmp7_ = FALSE;
#line 122 "../app/ConfigLocationRow.vala"
				_tmp9_ = self->priv->store;
#line 122 "../app/ConfigLocationRow.vala"
				if (!(i < g_list_model_get_n_items ((GListModel*) _tmp9_))) {
#line 122 "../app/ConfigLocationRow.vala"
					break;
#line 788 "ConfigLocationRow.c"
				}
#line 123 "../app/ConfigLocationRow.vala"
				_tmp10_ = self->priv->store;
#line 123 "../app/ConfigLocationRow.vala"
				_tmp11_ = g_list_model_get_item ((GListModel*) _tmp10_, i);
#line 123 "../app/ConfigLocationRow.vala"
				item = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, CONFIG_LOCATION_ROW_TYPE_ITEM, ConfigLocationRowItem);
#line 124 "../app/ConfigLocationRow.vala"
				_tmp13_ = full_id;
#line 124 "../app/ConfigLocationRow.vala"
				if (_tmp13_ == NULL) {
#line 124 "../app/ConfigLocationRow.vala"
					_tmp12_ = TRUE;
#line 802 "ConfigLocationRow.c"
				} else {
					ConfigLocationRowItem* _tmp14_;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
#line 124 "../app/ConfigLocationRow.vala"
					_tmp14_ = item;
#line 124 "../app/ConfigLocationRow.vala"
					_tmp15_ = config_location_row_item_get_id (_tmp14_);
#line 124 "../app/ConfigLocationRow.vala"
					_tmp16_ = _tmp15_;
#line 124 "../app/ConfigLocationRow.vala"
					_tmp17_ = full_id;
#line 124 "../app/ConfigLocationRow.vala"
					_tmp12_ = g_strcmp0 (_tmp16_, _tmp17_) == 0;
#line 818 "ConfigLocationRow.c"
				}
#line 124 "../app/ConfigLocationRow.vala"
				if (_tmp12_) {
#line 125 "../app/ConfigLocationRow.vala"
					_vala_position = i;
#line 126 "../app/ConfigLocationRow.vala"
					result = item;
#line 126 "../app/ConfigLocationRow.vala"
					_g_free0 (full_id);
#line 126 "../app/ConfigLocationRow.vala"
					_g_free0 (_tmp0_);
#line 126 "../app/ConfigLocationRow.vala"
					if (position) {
#line 126 "../app/ConfigLocationRow.vala"
						*position = _vala_position;
#line 834 "ConfigLocationRow.c"
					}
#line 126 "../app/ConfigLocationRow.vala"
					return result;
#line 838 "ConfigLocationRow.c"
				}
#line 122 "../app/ConfigLocationRow.vala"
				_g_object_unref0 (item);
#line 842 "ConfigLocationRow.c"
			}
		}
	}
#line 130 "../app/ConfigLocationRow.vala"
	result = NULL;
#line 130 "../app/ConfigLocationRow.vala"
	_g_free0 (full_id);
#line 130 "../app/ConfigLocationRow.vala"
	_g_free0 (_tmp0_);
#line 130 "../app/ConfigLocationRow.vala"
	if (position) {
#line 130 "../app/ConfigLocationRow.vala"
		*position = _vala_position;
#line 856 "ConfigLocationRow.c"
	}
#line 130 "../app/ConfigLocationRow.vala"
	return result;
#line 860 "ConfigLocationRow.c"
}

static void
config_location_row_add_volume (ConfigLocationRow* self,
                                GVolumeMonitor* monitor,
                                GVolume* v)
{
#line 133 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 133 "../app/ConfigLocationRow.vala"
	g_return_if_fail (monitor != NULL);
#line 133 "../app/ConfigLocationRow.vala"
	g_return_if_fail (v != NULL);
#line 135 "../app/ConfigLocationRow.vala"
	if (deja_dup_backend_drive_is_allowed_volume (v)) {
#line 876 "ConfigLocationRow.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GIcon* _tmp4_;
		GIcon* _tmp5_;
#line 137 "../app/ConfigLocationRow.vala"
		_tmp0_ = deja_dup_backend_drive_get_uuid (v);
#line 137 "../app/ConfigLocationRow.vala"
		_tmp1_ = _tmp0_;
#line 137 "../app/ConfigLocationRow.vala"
		_tmp2_ = g_volume_get_name (v);
#line 137 "../app/ConfigLocationRow.vala"
		_tmp3_ = _tmp2_;
#line 137 "../app/ConfigLocationRow.vala"
		_tmp4_ = g_volume_get_icon (v);
#line 137 "../app/ConfigLocationRow.vala"
		_tmp5_ = _tmp4_;
#line 137 "../app/ConfigLocationRow.vala"
		config_location_row_add_volume_full (self, _tmp1_, _tmp3_, _tmp5_);
#line 137 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (_tmp5_);
#line 137 "../app/ConfigLocationRow.vala"
		_g_free0 (_tmp3_);
#line 137 "../app/ConfigLocationRow.vala"
		_g_free0 (_tmp1_);
#line 903 "ConfigLocationRow.c"
	}
}

static guint
config_location_row_add_volume_full (ConfigLocationRow* self,
                                     const gchar* uuid,
                                     const gchar* name,
                                     GIcon* icon)
{
	guint position = 0U;
	gchar* _tmp0_;
	gchar* _tmp1_;
	guint _tmp2_;
	guint result;
#line 141 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 141 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (uuid != NULL, 0U);
#line 141 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (name != NULL, 0U);
#line 141 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (icon != NULL, 0U);
#line 143 "../app/ConfigLocationRow.vala"
	position = config_location_row_update_volume_full (self, uuid, name, icon);
#line 144 "../app/ConfigLocationRow.vala"
	if (position != G_MAXUINT) {
#line 145 "../app/ConfigLocationRow.vala"
		result = position;
#line 145 "../app/ConfigLocationRow.vala"
		return result;
#line 934 "ConfigLocationRow.c"
	}
#line 147 "../app/ConfigLocationRow.vala"
	_tmp0_ = g_strconcat ("drive:", uuid, NULL);
#line 147 "../app/ConfigLocationRow.vala"
	_tmp1_ = _tmp0_;
#line 147 "../app/ConfigLocationRow.vala"
	_tmp2_ = config_location_row_add_entry_full (self, _tmp1_, icon, name, CONFIG_LOCATION_ROW_GROUP_VOLUMES, "drive", DEJA_DUP_BACKEND_KIND_LOCAL);
#line 147 "../app/ConfigLocationRow.vala"
	_g_free0 (_tmp1_);
#line 147 "../app/ConfigLocationRow.vala"
	result = _tmp2_;
#line 147 "../app/ConfigLocationRow.vala"
	return result;
#line 948 "ConfigLocationRow.c"
}

static void
config_location_row_update_volume (ConfigLocationRow* self,
                                   GVolumeMonitor* monitor,
                                   GVolume* v)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
#line 151 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 151 "../app/ConfigLocationRow.vala"
	g_return_if_fail (monitor != NULL);
#line 151 "../app/ConfigLocationRow.vala"
	g_return_if_fail (v != NULL);
#line 153 "../app/ConfigLocationRow.vala"
	_tmp0_ = deja_dup_backend_drive_get_uuid (v);
#line 153 "../app/ConfigLocationRow.vala"
	_tmp1_ = _tmp0_;
#line 153 "../app/ConfigLocationRow.vala"
	_tmp2_ = g_volume_get_name (v);
#line 153 "../app/ConfigLocationRow.vala"
	_tmp3_ = _tmp2_;
#line 153 "../app/ConfigLocationRow.vala"
	_tmp4_ = g_volume_get_icon (v);
#line 153 "../app/ConfigLocationRow.vala"
	_tmp5_ = _tmp4_;
#line 153 "../app/ConfigLocationRow.vala"
	config_location_row_update_volume_full (self, _tmp1_, _tmp3_, _tmp5_);
#line 153 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (_tmp5_);
#line 153 "../app/ConfigLocationRow.vala"
	_g_free0 (_tmp3_);
#line 153 "../app/ConfigLocationRow.vala"
	_g_free0 (_tmp1_);
#line 988 "ConfigLocationRow.c"
}

static guint
config_location_row_update_volume_full (ConfigLocationRow* self,
                                        const gchar* uuid,
                                        const gchar* name,
                                        GIcon* icon)
{
	guint position = 0U;
	ConfigLocationRowItem* item = NULL;
	guint _tmp0_ = 0U;
	ConfigLocationRowItem* _tmp1_;
	ConfigLocationRowItem* _tmp2_;
	ConfigLocationRowItem* _tmp3_;
	ConfigLocationRowItem* _tmp4_;
	guint result;
#line 156 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 156 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (uuid != NULL, 0U);
#line 156 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (name != NULL, 0U);
#line 156 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (icon != NULL, 0U);
#line 159 "../app/ConfigLocationRow.vala"
	_tmp1_ = config_location_row_lookup_id (self, "drive", uuid, &_tmp0_);
#line 159 "../app/ConfigLocationRow.vala"
	position = _tmp0_;
#line 159 "../app/ConfigLocationRow.vala"
	item = _tmp1_;
#line 160 "../app/ConfigLocationRow.vala"
	_tmp2_ = item;
#line 160 "../app/ConfigLocationRow.vala"
	if (_tmp2_ == NULL) {
#line 161 "../app/ConfigLocationRow.vala"
		result = G_MAXUINT;
#line 161 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (item);
#line 161 "../app/ConfigLocationRow.vala"
		return result;
#line 1029 "ConfigLocationRow.c"
	}
#line 163 "../app/ConfigLocationRow.vala"
	_tmp3_ = item;
#line 163 "../app/ConfigLocationRow.vala"
	config_location_row_item_set_icon (_tmp3_, icon);
#line 164 "../app/ConfigLocationRow.vala"
	_tmp4_ = item;
#line 164 "../app/ConfigLocationRow.vala"
	config_location_row_item_set_text (_tmp4_, name);
#line 165 "../app/ConfigLocationRow.vala"
	result = position;
#line 165 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (item);
#line 165 "../app/ConfigLocationRow.vala"
	return result;
#line 1045 "ConfigLocationRow.c"
}

static void
config_location_row_remove_volume (ConfigLocationRow* self,
                                   GVolumeMonitor* monitor,
                                   GVolume* v)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 168 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 168 "../app/ConfigLocationRow.vala"
	g_return_if_fail (monitor != NULL);
#line 168 "../app/ConfigLocationRow.vala"
	g_return_if_fail (v != NULL);
#line 170 "../app/ConfigLocationRow.vala"
	_tmp0_ = deja_dup_backend_drive_get_uuid (v);
#line 170 "../app/ConfigLocationRow.vala"
	_tmp1_ = _tmp0_;
#line 170 "../app/ConfigLocationRow.vala"
	config_location_row_remove_volume_full (self, _tmp1_);
#line 170 "../app/ConfigLocationRow.vala"
	_g_free0 (_tmp1_);
#line 1069 "ConfigLocationRow.c"
}

static void
config_location_row_remove_volume_full (ConfigLocationRow* self,
                                        const gchar* uuid)
{
	guint position = 0U;
	ConfigLocationRowItem* item = NULL;
	guint _tmp0_ = 0U;
	ConfigLocationRowItem* _tmp1_;
	ConfigLocationRowItem* _tmp2_;
	gchar* saved_uuid = NULL;
	DejaDupFilteredSettings* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	GListStore* _tmp6_;
#line 173 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 173 "../app/ConfigLocationRow.vala"
	g_return_if_fail (uuid != NULL);
#line 176 "../app/ConfigLocationRow.vala"
	_tmp1_ = config_location_row_lookup_id (self, "drive", uuid, &_tmp0_);
#line 176 "../app/ConfigLocationRow.vala"
	position = _tmp0_;
#line 176 "../app/ConfigLocationRow.vala"
	item = _tmp1_;
#line 177 "../app/ConfigLocationRow.vala"
	_tmp2_ = item;
#line 177 "../app/ConfigLocationRow.vala"
	if (_tmp2_ == NULL) {
#line 178 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (item);
#line 178 "../app/ConfigLocationRow.vala"
		return;
#line 1104 "ConfigLocationRow.c"
	}
#line 181 "../app/ConfigLocationRow.vala"
	_tmp3_ = self->priv->_drive_settings;
#line 181 "../app/ConfigLocationRow.vala"
	_tmp4_ = g_settings_get_string ((GSettings*) _tmp3_, DEJA_DUP_DRIVE_UUID_KEY);
#line 181 "../app/ConfigLocationRow.vala"
	saved_uuid = _tmp4_;
#line 182 "../app/ConfigLocationRow.vala"
	_tmp5_ = saved_uuid;
#line 182 "../app/ConfigLocationRow.vala"
	if (g_strcmp0 (uuid, _tmp5_) == 0) {
#line 183 "../app/ConfigLocationRow.vala"
		_g_free0 (saved_uuid);
#line 183 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (item);
#line 183 "../app/ConfigLocationRow.vala"
		return;
#line 1122 "ConfigLocationRow.c"
	}
#line 185 "../app/ConfigLocationRow.vala"
	_tmp6_ = self->priv->store;
#line 185 "../app/ConfigLocationRow.vala"
	g_list_store_remove (_tmp6_, position);
#line 173 "../app/ConfigLocationRow.vala"
	_g_free0 (saved_uuid);
#line 173 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (item);
#line 1132 "ConfigLocationRow.c"
}

static guint
config_location_row_add_saved_volume (ConfigLocationRow* self)
{
	gchar* uuid = NULL;
	DejaDupFilteredSettings* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	guint position = 0U;
	ConfigLocationRowItem* item = NULL;
	const gchar* _tmp3_;
	guint _tmp4_ = 0U;
	ConfigLocationRowItem* _tmp5_;
	ConfigLocationRowItem* _tmp6_;
	GIcon* vol_icon = NULL;
	gchar* vol_name = NULL;
	DejaDupFilteredSettings* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	GIcon* _tmp20_;
	GError* _inner_error0_ = NULL;
	guint result;
#line 189 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 191 "../app/ConfigLocationRow.vala"
	_tmp0_ = self->priv->_drive_settings;
#line 191 "../app/ConfigLocationRow.vala"
	_tmp1_ = g_settings_get_string ((GSettings*) _tmp0_, DEJA_DUP_DRIVE_UUID_KEY);
#line 191 "../app/ConfigLocationRow.vala"
	uuid = _tmp1_;
#line 192 "../app/ConfigLocationRow.vala"
	_tmp2_ = uuid;
#line 192 "../app/ConfigLocationRow.vala"
	if (g_strcmp0 (_tmp2_, "") == 0) {
#line 193 "../app/ConfigLocationRow.vala"
		result = G_MAXUINT;
#line 193 "../app/ConfigLocationRow.vala"
		_g_free0 (uuid);
#line 193 "../app/ConfigLocationRow.vala"
		return result;
#line 1175 "ConfigLocationRow.c"
	}
#line 196 "../app/ConfigLocationRow.vala"
	_tmp3_ = uuid;
#line 196 "../app/ConfigLocationRow.vala"
	_tmp5_ = config_location_row_lookup_id (self, "drive", _tmp3_, &_tmp4_);
#line 196 "../app/ConfigLocationRow.vala"
	position = _tmp4_;
#line 196 "../app/ConfigLocationRow.vala"
	item = _tmp5_;
#line 197 "../app/ConfigLocationRow.vala"
	_tmp6_ = item;
#line 197 "../app/ConfigLocationRow.vala"
	if (_tmp6_ != NULL) {
#line 198 "../app/ConfigLocationRow.vala"
		result = position;
#line 198 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (item);
#line 198 "../app/ConfigLocationRow.vala"
		_g_free0 (uuid);
#line 198 "../app/ConfigLocationRow.vala"
		return result;
#line 1197 "ConfigLocationRow.c"
	}
#line 200 "../app/ConfigLocationRow.vala"
	vol_icon = NULL;
#line 1201 "ConfigLocationRow.c"
	{
		gchar* icon_string = NULL;
		DejaDupFilteredSettings* _tmp7_;
		gchar* _tmp8_;
		GIcon* _tmp9_ = NULL;
		const gchar* _tmp10_;
		GIcon* _tmp11_;
		GIcon* _tmp12_;
#line 202 "../app/ConfigLocationRow.vala"
		_tmp7_ = self->priv->_drive_settings;
#line 202 "../app/ConfigLocationRow.vala"
		_tmp8_ = g_settings_get_string ((GSettings*) _tmp7_, DEJA_DUP_DRIVE_ICON_KEY);
#line 202 "../app/ConfigLocationRow.vala"
		icon_string = _tmp8_;
#line 203 "../app/ConfigLocationRow.vala"
		_tmp10_ = icon_string;
#line 203 "../app/ConfigLocationRow.vala"
		_tmp11_ = g_icon_new_for_string (_tmp10_, &_inner_error0_);
#line 203 "../app/ConfigLocationRow.vala"
		_tmp9_ = _tmp11_;
#line 203 "../app/ConfigLocationRow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 203 "../app/ConfigLocationRow.vala"
			_g_free0 (icon_string);
#line 1226 "ConfigLocationRow.c"
			goto __catch0_g_error;
		}
#line 203 "../app/ConfigLocationRow.vala"
		_tmp12_ = _tmp9_;
#line 203 "../app/ConfigLocationRow.vala"
		_tmp9_ = NULL;
#line 203 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (vol_icon);
#line 203 "../app/ConfigLocationRow.vala"
		vol_icon = _tmp12_;
#line 201 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (_tmp9_);
#line 201 "../app/ConfigLocationRow.vala"
		_g_free0 (icon_string);
#line 1241 "ConfigLocationRow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 201 "../app/ConfigLocationRow.vala"
		e = _inner_error0_;
#line 201 "../app/ConfigLocationRow.vala"
		_inner_error0_ = NULL;
#line 205 "../app/ConfigLocationRow.vala"
		_tmp13_ = e;
#line 205 "../app/ConfigLocationRow.vala"
		_tmp14_ = _tmp13_->message;
#line 205 "../app/ConfigLocationRow.vala"
		g_warning ("ConfigLocationRow.vala:205: %s\n", _tmp14_);
#line 201 "../app/ConfigLocationRow.vala"
		_g_error_free0 (e);
#line 1261 "ConfigLocationRow.c"
	}
	__finally0:
#line 201 "../app/ConfigLocationRow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1266 "ConfigLocationRow.c"
		guint _tmp15_ = 0U;
#line 201 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (vol_icon);
#line 201 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (item);
#line 201 "../app/ConfigLocationRow.vala"
		_g_free0 (uuid);
#line 201 "../app/ConfigLocationRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 201 "../app/ConfigLocationRow.vala"
		g_clear_error (&_inner_error0_);
#line 201 "../app/ConfigLocationRow.vala"
		return _tmp15_;
#line 1280 "ConfigLocationRow.c"
	}
#line 207 "../app/ConfigLocationRow.vala"
	_tmp16_ = self->priv->_drive_settings;
#line 207 "../app/ConfigLocationRow.vala"
	_tmp17_ = g_settings_get_string ((GSettings*) _tmp16_, DEJA_DUP_DRIVE_NAME_KEY);
#line 207 "../app/ConfigLocationRow.vala"
	vol_name = _tmp17_;
#line 209 "../app/ConfigLocationRow.vala"
	_tmp18_ = uuid;
#line 209 "../app/ConfigLocationRow.vala"
	_tmp19_ = vol_name;
#line 209 "../app/ConfigLocationRow.vala"
	_tmp20_ = vol_icon;
#line 209 "../app/ConfigLocationRow.vala"
	result = config_location_row_add_volume_full (self, _tmp18_, _tmp19_, _tmp20_);
#line 209 "../app/ConfigLocationRow.vala"
	_g_free0 (vol_name);
#line 209 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (vol_icon);
#line 209 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (item);
#line 209 "../app/ConfigLocationRow.vala"
	_g_free0 (uuid);
#line 209 "../app/ConfigLocationRow.vala"
	return result;
#line 1306 "ConfigLocationRow.c"
}

static gboolean
config_location_row_get_mapping (GValue* val,
                                 GVariant* variant,
                                 void* data)
{
	ConfigLocationRow* _self_ = NULL;
	ConfigLocationRow* _tmp0_;
	guint position = 0U;
	gchar* id = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp4_;
	gboolean result;
#line 212 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (val != NULL, FALSE);
#line 212 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (variant != NULL, FALSE);
#line 214 "../app/ConfigLocationRow.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (data, TYPE_CONFIG_LOCATION_ROW, ConfigLocationRow));
#line 214 "../app/ConfigLocationRow.vala"
	_self_ = _tmp0_;
#line 217 "../app/ConfigLocationRow.vala"
	_tmp1_ = g_variant_get_string (variant, NULL);
#line 217 "../app/ConfigLocationRow.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 217 "../app/ConfigLocationRow.vala"
	id = _tmp2_;
#line 218 "../app/ConfigLocationRow.vala"
	if (deja_dup_in_demo_mode ()) {
#line 1338 "ConfigLocationRow.c"
		gchar* _tmp3_;
#line 219 "../app/ConfigLocationRow.vala"
		_tmp3_ = g_strdup ("google");
#line 219 "../app/ConfigLocationRow.vala"
		_g_free0 (id);
#line 219 "../app/ConfigLocationRow.vala"
		id = _tmp3_;
#line 1346 "ConfigLocationRow.c"
	}
#line 221 "../app/ConfigLocationRow.vala"
	_tmp4_ = id;
#line 221 "../app/ConfigLocationRow.vala"
	if (g_strcmp0 (_tmp4_, "drive") == 0) {
#line 1352 "ConfigLocationRow.c"
		ConfigLocationRow* _tmp5_;
#line 222 "../app/ConfigLocationRow.vala"
		_tmp5_ = _self_;
#line 222 "../app/ConfigLocationRow.vala"
		position = config_location_row_add_saved_volume (_tmp5_);
#line 1358 "ConfigLocationRow.c"
	} else {
		ConfigLocationRow* _tmp6_;
		const gchar* _tmp7_;
		guint _tmp8_ = 0U;
		ConfigLocationRowItem* _tmp9_;
		ConfigLocationRowItem* _tmp10_;
#line 225 "../app/ConfigLocationRow.vala"
		_tmp6_ = _self_;
#line 225 "../app/ConfigLocationRow.vala"
		_tmp7_ = id;
#line 225 "../app/ConfigLocationRow.vala"
		_tmp9_ = config_location_row_lookup_id (_tmp6_, NULL, _tmp7_, &_tmp8_);
#line 225 "../app/ConfigLocationRow.vala"
		position = _tmp8_;
#line 225 "../app/ConfigLocationRow.vala"
		_tmp10_ = _tmp9_;
#line 225 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (_tmp10_);
#line 1377 "ConfigLocationRow.c"
	}
#line 228 "../app/ConfigLocationRow.vala"
	if (position == G_MAXUINT) {
#line 229 "../app/ConfigLocationRow.vala"
		result = FALSE;
#line 229 "../app/ConfigLocationRow.vala"
		_g_free0 (id);
#line 229 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (_self_);
#line 229 "../app/ConfigLocationRow.vala"
		return result;
#line 1389 "ConfigLocationRow.c"
	}
#line 231 "../app/ConfigLocationRow.vala"
	g_value_set_uint (val, position);
#line 232 "../app/ConfigLocationRow.vala"
	result = TRUE;
#line 232 "../app/ConfigLocationRow.vala"
	_g_free0 (id);
#line 232 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (_self_);
#line 232 "../app/ConfigLocationRow.vala"
	return result;
#line 1401 "ConfigLocationRow.c"
}

static GVariant*
config_location_row_set_mapping (GValue* val,
                                 const GVariantType* expected_type,
                                 void* data)
{
	ConfigLocationRow* _self_ = NULL;
	ConfigLocationRow* _tmp0_;
	guint position = 0U;
	ConfigLocationRowItem* item = NULL;
	ConfigLocationRow* _tmp1_;
	GListStore* _tmp2_;
	GObject* _tmp3_;
	gchar* id = NULL;
	ConfigLocationRowItem* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** parts = NULL;
	const gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	const gchar* _tmp20_;
	GVariant* _tmp21_;
	GVariant* result;
#line 235 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (val != NULL, NULL);
#line 235 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (expected_type != NULL, NULL);
#line 237 "../app/ConfigLocationRow.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (data, TYPE_CONFIG_LOCATION_ROW, ConfigLocationRow));
#line 237 "../app/ConfigLocationRow.vala"
	_self_ = _tmp0_;
#line 238 "../app/ConfigLocationRow.vala"
	position = g_value_get_uint (val);
#line 239 "../app/ConfigLocationRow.vala"
	_tmp1_ = _self_;
#line 239 "../app/ConfigLocationRow.vala"
	_tmp2_ = _tmp1_->priv->store;
#line 239 "../app/ConfigLocationRow.vala"
	_tmp3_ = g_list_model_get_item ((GListModel*) _tmp2_, position);
#line 239 "../app/ConfigLocationRow.vala"
	item = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, CONFIG_LOCATION_ROW_TYPE_ITEM, ConfigLocationRowItem);
#line 240 "../app/ConfigLocationRow.vala"
	_tmp4_ = item;
#line 240 "../app/ConfigLocationRow.vala"
	_tmp5_ = config_location_row_item_get_id (_tmp4_);
#line 240 "../app/ConfigLocationRow.vala"
	_tmp6_ = _tmp5_;
#line 240 "../app/ConfigLocationRow.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 240 "../app/ConfigLocationRow.vala"
	id = _tmp7_;
#line 242 "../app/ConfigLocationRow.vala"
	_tmp8_ = id;
#line 242 "../app/ConfigLocationRow.vala"
	_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, ":", 2);
#line 242 "../app/ConfigLocationRow.vala"
	parts = _tmp10_;
#line 242 "../app/ConfigLocationRow.vala"
	parts_length1 = _vala_array_length (_tmp9_);
#line 242 "../app/ConfigLocationRow.vala"
	_parts_size_ = parts_length1;
#line 243 "../app/ConfigLocationRow.vala"
	_tmp11_ = parts;
#line 243 "../app/ConfigLocationRow.vala"
	_tmp11__length1 = parts_length1;
#line 243 "../app/ConfigLocationRow.vala"
	if (_tmp11__length1 == 2) {
#line 1476 "ConfigLocationRow.c"
		gchar** _tmp12_;
		gint _tmp12__length1;
		const gchar* _tmp13_;
		gchar** _tmp17_;
		gint _tmp17__length1;
		const gchar* _tmp18_;
		gchar* _tmp19_;
#line 244 "../app/ConfigLocationRow.vala"
		_tmp12_ = parts;
#line 244 "../app/ConfigLocationRow.vala"
		_tmp12__length1 = parts_length1;
#line 244 "../app/ConfigLocationRow.vala"
		_tmp13_ = _tmp12_[0];
#line 244 "../app/ConfigLocationRow.vala"
		if (g_strcmp0 (_tmp13_, "drive") == 0) {
#line 1492 "ConfigLocationRow.c"
			ConfigLocationRow* _tmp14_;
			gchar** _tmp15_;
			gint _tmp15__length1;
			const gchar* _tmp16_;
#line 245 "../app/ConfigLocationRow.vala"
			_tmp14_ = _self_;
#line 245 "../app/ConfigLocationRow.vala"
			_tmp15_ = parts;
#line 245 "../app/ConfigLocationRow.vala"
			_tmp15__length1 = parts_length1;
#line 245 "../app/ConfigLocationRow.vala"
			_tmp16_ = _tmp15_[1];
#line 245 "../app/ConfigLocationRow.vala"
			config_location_row_set_volume_info (_tmp14_, _tmp16_);
#line 1507 "ConfigLocationRow.c"
		}
#line 246 "../app/ConfigLocationRow.vala"
		_tmp17_ = parts;
#line 246 "../app/ConfigLocationRow.vala"
		_tmp17__length1 = parts_length1;
#line 246 "../app/ConfigLocationRow.vala"
		_tmp18_ = _tmp17_[0];
#line 246 "../app/ConfigLocationRow.vala"
		_tmp19_ = g_strdup (_tmp18_);
#line 246 "../app/ConfigLocationRow.vala"
		_g_free0 (id);
#line 246 "../app/ConfigLocationRow.vala"
		id = _tmp19_;
#line 1521 "ConfigLocationRow.c"
	}
#line 249 "../app/ConfigLocationRow.vala"
	_tmp20_ = id;
#line 249 "../app/ConfigLocationRow.vala"
	_tmp21_ = g_variant_new_string (_tmp20_);
#line 249 "../app/ConfigLocationRow.vala"
	g_variant_ref_sink (_tmp21_);
#line 249 "../app/ConfigLocationRow.vala"
	result = _tmp21_;
#line 249 "../app/ConfigLocationRow.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 249 "../app/ConfigLocationRow.vala"
	_g_free0 (id);
#line 249 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (item);
#line 249 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (_self_);
#line 249 "../app/ConfigLocationRow.vala"
	return result;
#line 1541 "ConfigLocationRow.c"
}

static void
config_location_row_handle_drive_uuid_change (ConfigLocationRow* self)
{
	guint position = 0U;
#line 252 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 254 "../app/ConfigLocationRow.vala"
	position = config_location_row_add_saved_volume (self);
#line 255 "../app/ConfigLocationRow.vala"
	if (position != G_MAXUINT) {
#line 256 "../app/ConfigLocationRow.vala"
		adw_combo_row_set_selected ((AdwComboRow*) self, position);
#line 1556 "ConfigLocationRow.c"
	}
}

static void
config_location_row_set_volume_info (ConfigLocationRow* self,
                                     const gchar* uuid)
{
	DejaDupFilteredSettings* _tmp0_;
	GVolume* vol = NULL;
	GVolume* _tmp1_;
	GVolume* _tmp2_;
	DejaDupFilteredSettings* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 259 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 259 "../app/ConfigLocationRow.vala"
	g_return_if_fail (uuid != NULL);
#line 261 "../app/ConfigLocationRow.vala"
	_tmp0_ = self->priv->_drive_settings;
#line 261 "../app/ConfigLocationRow.vala"
	deja_dup_filtered_settings_set_string (_tmp0_, DEJA_DUP_DRIVE_UUID_KEY, uuid);
#line 263 "../app/ConfigLocationRow.vala"
	_tmp1_ = deja_dup_backend_drive_find_volume (uuid);
#line 263 "../app/ConfigLocationRow.vala"
	vol = _tmp1_;
#line 264 "../app/ConfigLocationRow.vala"
	_tmp2_ = vol;
#line 264 "../app/ConfigLocationRow.vala"
	if (_tmp2_ == NULL) {
#line 266 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (vol);
#line 266 "../app/ConfigLocationRow.vala"
		return;
#line 1591 "ConfigLocationRow.c"
	}
#line 269 "../app/ConfigLocationRow.vala"
	_tmp3_ = self->priv->_drive_settings;
#line 269 "../app/ConfigLocationRow.vala"
	_tmp4_ = deja_dup_filtered_settings_get_read_only (_tmp3_);
#line 269 "../app/ConfigLocationRow.vala"
	_tmp5_ = _tmp4_;
#line 269 "../app/ConfigLocationRow.vala"
	if (!_tmp5_) {
#line 1601 "ConfigLocationRow.c"
		GVolume* _tmp6_;
		DejaDupFilteredSettings* _tmp7_;
#line 270 "../app/ConfigLocationRow.vala"
		_tmp6_ = vol;
#line 270 "../app/ConfigLocationRow.vala"
		_tmp7_ = self->priv->_drive_settings;
#line 270 "../app/ConfigLocationRow.vala"
		deja_dup_backend_drive_update_volume_info (_tmp6_, (GSettings*) _tmp7_);
#line 1610 "ConfigLocationRow.c"
	}
#line 259 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (vol);
#line 1614 "ConfigLocationRow.c"
}

ConfigLocationRow*
config_location_row_construct (GType object_type)
{
	ConfigLocationRow * self = NULL;
#line 10 "../app/ConfigLocationRow.vala"
	self = (ConfigLocationRow*) g_object_new (object_type, NULL);
#line 10 "../app/ConfigLocationRow.vala"
	return self;
#line 1625 "ConfigLocationRow.c"
}

ConfigLocationRow*
config_location_row_new (void)
{
#line 10 "../app/ConfigLocationRow.vala"
	return config_location_row_construct (TYPE_CONFIG_LOCATION_ROW);
#line 1633 "ConfigLocationRow.c"
}

DejaDupFilteredSettings*
config_location_row_get_settings (ConfigLocationRow* self)
{
	DejaDupFilteredSettings* result;
	DejaDupFilteredSettings* _tmp0_;
#line 12 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 12 "../app/ConfigLocationRow.vala"
	_tmp0_ = self->priv->_settings;
#line 12 "../app/ConfigLocationRow.vala"
	result = _tmp0_;
#line 12 "../app/ConfigLocationRow.vala"
	return result;
#line 1649 "ConfigLocationRow.c"
}

static void
config_location_row_set_settings (ConfigLocationRow* self,
                                  DejaDupFilteredSettings* value)
{
	DejaDupFilteredSettings* old_value;
#line 12 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 12 "../app/ConfigLocationRow.vala"
	old_value = config_location_row_get_settings (self);
#line 12 "../app/ConfigLocationRow.vala"
	if (old_value != value) {
#line 1663 "ConfigLocationRow.c"
		DejaDupFilteredSettings* _tmp0_;
#line 12 "../app/ConfigLocationRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 12 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (self->priv->_settings);
#line 12 "../app/ConfigLocationRow.vala"
		self->priv->_settings = _tmp0_;
#line 12 "../app/ConfigLocationRow.vala"
		g_object_notify_by_pspec ((GObject *) self, config_location_row_properties[CONFIG_LOCATION_ROW_SETTINGS_PROPERTY]);
#line 1673 "ConfigLocationRow.c"
	}
}

DejaDupFilteredSettings*
config_location_row_get_drive_settings (ConfigLocationRow* self)
{
	DejaDupFilteredSettings* result;
	DejaDupFilteredSettings* _tmp0_;
#line 13 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 13 "../app/ConfigLocationRow.vala"
	_tmp0_ = self->priv->_drive_settings;
#line 13 "../app/ConfigLocationRow.vala"
	result = _tmp0_;
#line 13 "../app/ConfigLocationRow.vala"
	return result;
#line 1690 "ConfigLocationRow.c"
}

static void
config_location_row_set_drive_settings (ConfigLocationRow* self,
                                        DejaDupFilteredSettings* value)
{
	DejaDupFilteredSettings* old_value;
#line 13 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 13 "../app/ConfigLocationRow.vala"
	old_value = config_location_row_get_drive_settings (self);
#line 13 "../app/ConfigLocationRow.vala"
	if (old_value != value) {
#line 1704 "ConfigLocationRow.c"
		DejaDupFilteredSettings* _tmp0_;
#line 13 "../app/ConfigLocationRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 13 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (self->priv->_drive_settings);
#line 13 "../app/ConfigLocationRow.vala"
		self->priv->_drive_settings = _tmp0_;
#line 13 "../app/ConfigLocationRow.vala"
		g_object_notify_by_pspec ((GObject *) self, config_location_row_properties[CONFIG_LOCATION_ROW_DRIVE_SETTINGS_PROPERTY]);
#line 1714 "ConfigLocationRow.c"
	}
}

static inline gpointer
config_location_row_item_get_instance_private (ConfigLocationRowItem* self)
{
	return G_STRUCT_MEMBER_P (self, ConfigLocationRowItem_private_offset);
}

ConfigLocationRowItem*
config_location_row_item_construct (GType object_type,
                                    GIcon* icon,
                                    const gchar* text,
                                    const gchar* sort_key,
                                    const gchar* id,
                                    const gchar* page,
                                    DejaDupBackendKind backend_kind)
{
	ConfigLocationRowItem * self = NULL;
#line 23 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 23 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (sort_key != NULL, NULL);
#line 23 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 23 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 26 "../app/ConfigLocationRow.vala"
	self = (ConfigLocationRowItem*) g_object_new (object_type, "icon", icon, "text", text, "sort-key", sort_key, "id", id, "page", page, "backend-kind", backend_kind, NULL);
#line 23 "../app/ConfigLocationRow.vala"
	return self;
#line 1746 "ConfigLocationRow.c"
}

ConfigLocationRowItem*
config_location_row_item_new (GIcon* icon,
                              const gchar* text,
                              const gchar* sort_key,
                              const gchar* id,
                              const gchar* page,
                              DejaDupBackendKind backend_kind)
{
#line 23 "../app/ConfigLocationRow.vala"
	return config_location_row_item_construct (CONFIG_LOCATION_ROW_TYPE_ITEM, icon, text, sort_key, id, page, backend_kind);
#line 1759 "ConfigLocationRow.c"
}

GIcon*
config_location_row_item_get_icon (ConfigLocationRowItem* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 16 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 16 "../app/ConfigLocationRow.vala"
	_tmp0_ = self->priv->_icon;
#line 16 "../app/ConfigLocationRow.vala"
	result = _tmp0_;
#line 16 "../app/ConfigLocationRow.vala"
	return result;
#line 1775 "ConfigLocationRow.c"
}

void
config_location_row_item_set_icon (ConfigLocationRowItem* self,
                                   GIcon* value)
{
	GIcon* old_value;
#line 16 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 16 "../app/ConfigLocationRow.vala"
	old_value = config_location_row_item_get_icon (self);
#line 16 "../app/ConfigLocationRow.vala"
	if (old_value != value) {
#line 1789 "ConfigLocationRow.c"
		GIcon* _tmp0_;
#line 16 "../app/ConfigLocationRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 16 "../app/ConfigLocationRow.vala"
		_g_object_unref0 (self->priv->_icon);
#line 16 "../app/ConfigLocationRow.vala"
		self->priv->_icon = _tmp0_;
#line 16 "../app/ConfigLocationRow.vala"
		g_object_notify_by_pspec ((GObject *) self, config_location_row_item_properties[CONFIG_LOCATION_ROW_ITEM_ICON_PROPERTY]);
#line 1799 "ConfigLocationRow.c"
	}
}

const gchar*
config_location_row_item_get_text (ConfigLocationRowItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 17 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 17 "../app/ConfigLocationRow.vala"
	_tmp0_ = self->priv->_text;
#line 17 "../app/ConfigLocationRow.vala"
	result = _tmp0_;
#line 17 "../app/ConfigLocationRow.vala"
	return result;
#line 1816 "ConfigLocationRow.c"
}

void
config_location_row_item_set_text (ConfigLocationRowItem* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 17 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 17 "../app/ConfigLocationRow.vala"
	old_value = config_location_row_item_get_text (self);
#line 17 "../app/ConfigLocationRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1830 "ConfigLocationRow.c"
		gchar* _tmp0_;
#line 17 "../app/ConfigLocationRow.vala"
		_tmp0_ = g_strdup (value);
#line 17 "../app/ConfigLocationRow.vala"
		_g_free0 (self->priv->_text);
#line 17 "../app/ConfigLocationRow.vala"
		self->priv->_text = _tmp0_;
#line 17 "../app/ConfigLocationRow.vala"
		g_object_notify_by_pspec ((GObject *) self, config_location_row_item_properties[CONFIG_LOCATION_ROW_ITEM_TEXT_PROPERTY]);
#line 1840 "ConfigLocationRow.c"
	}
}

const gchar*
config_location_row_item_get_sort_key (ConfigLocationRowItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 18 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "../app/ConfigLocationRow.vala"
	_tmp0_ = self->priv->_sort_key;
#line 18 "../app/ConfigLocationRow.vala"
	result = _tmp0_;
#line 18 "../app/ConfigLocationRow.vala"
	return result;
#line 1857 "ConfigLocationRow.c"
}

static void
config_location_row_item_set_sort_key (ConfigLocationRowItem* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 18 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 18 "../app/ConfigLocationRow.vala"
	old_value = config_location_row_item_get_sort_key (self);
#line 18 "../app/ConfigLocationRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1871 "ConfigLocationRow.c"
		gchar* _tmp0_;
#line 18 "../app/ConfigLocationRow.vala"
		_tmp0_ = g_strdup (value);
#line 18 "../app/ConfigLocationRow.vala"
		_g_free0 (self->priv->_sort_key);
#line 18 "../app/ConfigLocationRow.vala"
		self->priv->_sort_key = _tmp0_;
#line 18 "../app/ConfigLocationRow.vala"
		g_object_notify_by_pspec ((GObject *) self, config_location_row_item_properties[CONFIG_LOCATION_ROW_ITEM_SORT_KEY_PROPERTY]);
#line 1881 "ConfigLocationRow.c"
	}
}

const gchar*
config_location_row_item_get_id (ConfigLocationRowItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 19 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../app/ConfigLocationRow.vala"
	_tmp0_ = self->priv->_id;
#line 19 "../app/ConfigLocationRow.vala"
	result = _tmp0_;
#line 19 "../app/ConfigLocationRow.vala"
	return result;
#line 1898 "ConfigLocationRow.c"
}

static void
config_location_row_item_set_id (ConfigLocationRowItem* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 19 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 19 "../app/ConfigLocationRow.vala"
	old_value = config_location_row_item_get_id (self);
#line 19 "../app/ConfigLocationRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1912 "ConfigLocationRow.c"
		gchar* _tmp0_;
#line 19 "../app/ConfigLocationRow.vala"
		_tmp0_ = g_strdup (value);
#line 19 "../app/ConfigLocationRow.vala"
		_g_free0 (self->priv->_id);
#line 19 "../app/ConfigLocationRow.vala"
		self->priv->_id = _tmp0_;
#line 19 "../app/ConfigLocationRow.vala"
		g_object_notify_by_pspec ((GObject *) self, config_location_row_item_properties[CONFIG_LOCATION_ROW_ITEM_ID_PROPERTY]);
#line 1922 "ConfigLocationRow.c"
	}
}

const gchar*
config_location_row_item_get_page (ConfigLocationRowItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 20 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../app/ConfigLocationRow.vala"
	_tmp0_ = self->priv->_page;
#line 20 "../app/ConfigLocationRow.vala"
	result = _tmp0_;
#line 20 "../app/ConfigLocationRow.vala"
	return result;
#line 1939 "ConfigLocationRow.c"
}

static void
config_location_row_item_set_page (ConfigLocationRowItem* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 20 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 20 "../app/ConfigLocationRow.vala"
	old_value = config_location_row_item_get_page (self);
#line 20 "../app/ConfigLocationRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1953 "ConfigLocationRow.c"
		gchar* _tmp0_;
#line 20 "../app/ConfigLocationRow.vala"
		_tmp0_ = g_strdup (value);
#line 20 "../app/ConfigLocationRow.vala"
		_g_free0 (self->priv->_page);
#line 20 "../app/ConfigLocationRow.vala"
		self->priv->_page = _tmp0_;
#line 20 "../app/ConfigLocationRow.vala"
		g_object_notify_by_pspec ((GObject *) self, config_location_row_item_properties[CONFIG_LOCATION_ROW_ITEM_PAGE_PROPERTY]);
#line 1963 "ConfigLocationRow.c"
	}
}

DejaDupBackendKind
config_location_row_item_get_backend_kind (ConfigLocationRowItem* self)
{
	DejaDupBackendKind result;
#line 21 "../app/ConfigLocationRow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 21 "../app/ConfigLocationRow.vala"
	result = self->priv->_backend_kind;
#line 21 "../app/ConfigLocationRow.vala"
	return result;
#line 1977 "ConfigLocationRow.c"
}

static void
config_location_row_item_set_backend_kind (ConfigLocationRowItem* self,
                                           DejaDupBackendKind value)
{
	DejaDupBackendKind old_value;
#line 21 "../app/ConfigLocationRow.vala"
	g_return_if_fail (self != NULL);
#line 21 "../app/ConfigLocationRow.vala"
	old_value = config_location_row_item_get_backend_kind (self);
#line 21 "../app/ConfigLocationRow.vala"
	if (old_value != value) {
#line 21 "../app/ConfigLocationRow.vala"
		self->priv->_backend_kind = value;
#line 21 "../app/ConfigLocationRow.vala"
		g_object_notify_by_pspec ((GObject *) self, config_location_row_item_properties[CONFIG_LOCATION_ROW_ITEM_BACKEND_KIND_PROPERTY]);
#line 1995 "ConfigLocationRow.c"
	}
}

static void
config_location_row_item_class_init (ConfigLocationRowItemClass * klass,
                                     gpointer klass_data)
{
#line 15 "../app/ConfigLocationRow.vala"
	config_location_row_item_parent_class = g_type_class_peek_parent (klass);
#line 15 "../app/ConfigLocationRow.vala"
	g_type_class_adjust_private_offset (klass, &ConfigLocationRowItem_private_offset);
#line 15 "../app/ConfigLocationRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_config_location_row_item_get_property;
#line 15 "../app/ConfigLocationRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_config_location_row_item_set_property;
#line 15 "../app/ConfigLocationRow.vala"
	G_OBJECT_CLASS (klass)->finalize = config_location_row_item_finalize;
#line 15 "../app/ConfigLocationRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONFIG_LOCATION_ROW_ITEM_ICON_PROPERTY, config_location_row_item_properties[CONFIG_LOCATION_ROW_ITEM_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "../app/ConfigLocationRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONFIG_LOCATION_ROW_ITEM_TEXT_PROPERTY, config_location_row_item_properties[CONFIG_LOCATION_ROW_ITEM_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "../app/ConfigLocationRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONFIG_LOCATION_ROW_ITEM_SORT_KEY_PROPERTY, config_location_row_item_properties[CONFIG_LOCATION_ROW_ITEM_SORT_KEY_PROPERTY] = g_param_spec_string ("sort-key", "sort-key", "sort-key", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 15 "../app/ConfigLocationRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONFIG_LOCATION_ROW_ITEM_ID_PROPERTY, config_location_row_item_properties[CONFIG_LOCATION_ROW_ITEM_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 15 "../app/ConfigLocationRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONFIG_LOCATION_ROW_ITEM_PAGE_PROPERTY, config_location_row_item_properties[CONFIG_LOCATION_ROW_ITEM_PAGE_PROPERTY] = g_param_spec_string ("page", "page", "page", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 15 "../app/ConfigLocationRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONFIG_LOCATION_ROW_ITEM_BACKEND_KIND_PROPERTY, config_location_row_item_properties[CONFIG_LOCATION_ROW_ITEM_BACKEND_KIND_PROPERTY] = g_param_spec_enum ("backend-kind", "backend-kind", "backend-kind", DEJA_DUP_BACKEND_TYPE_KIND, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2025 "ConfigLocationRow.c"
}

static void
config_location_row_item_instance_init (ConfigLocationRowItem * self,
                                        gpointer klass)
{
#line 15 "../app/ConfigLocationRow.vala"
	self->priv = config_location_row_item_get_instance_private (self);
#line 2034 "ConfigLocationRow.c"
}

static void
config_location_row_item_finalize (GObject * obj)
{
	ConfigLocationRowItem * self;
#line 15 "../app/ConfigLocationRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONFIG_LOCATION_ROW_TYPE_ITEM, ConfigLocationRowItem);
#line 16 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (self->priv->_icon);
#line 17 "../app/ConfigLocationRow.vala"
	_g_free0 (self->priv->_text);
#line 18 "../app/ConfigLocationRow.vala"
	_g_free0 (self->priv->_sort_key);
#line 19 "../app/ConfigLocationRow.vala"
	_g_free0 (self->priv->_id);
#line 20 "../app/ConfigLocationRow.vala"
	_g_free0 (self->priv->_page);
#line 15 "../app/ConfigLocationRow.vala"
	G_OBJECT_CLASS (config_location_row_item_parent_class)->finalize (obj);
#line 2055 "ConfigLocationRow.c"
}

 G_GNUC_NO_INLINE static GType
config_location_row_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConfigLocationRowItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) config_location_row_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConfigLocationRowItem), 0, (GInstanceInitFunc) config_location_row_item_instance_init, NULL };
	GType config_location_row_item_type_id;
	config_location_row_item_type_id = g_type_register_static (G_TYPE_OBJECT, "ConfigLocationRowItem", &g_define_type_info, 0);
	ConfigLocationRowItem_private_offset = g_type_add_instance_private (config_location_row_item_type_id, sizeof (ConfigLocationRowItemPrivate));
	return config_location_row_item_type_id;
}

GType
config_location_row_item_get_type (void)
{
	static gsize config_location_row_item_type_id__once = 0;
	if (g_once_init_enter (&config_location_row_item_type_id__once)) {
		GType config_location_row_item_type_id;
		config_location_row_item_type_id = config_location_row_item_get_type_once ();
		g_once_init_leave (&config_location_row_item_type_id__once, config_location_row_item_type_id);
	}
	return config_location_row_item_type_id__once;
}

static void
_vala_config_location_row_item_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	ConfigLocationRowItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONFIG_LOCATION_ROW_TYPE_ITEM, ConfigLocationRowItem);
#line 15 "../app/ConfigLocationRow.vala"
	switch (property_id) {
#line 15 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_ITEM_ICON_PROPERTY:
#line 15 "../app/ConfigLocationRow.vala"
		g_value_set_object (value, config_location_row_item_get_icon (self));
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 15 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_ITEM_TEXT_PROPERTY:
#line 15 "../app/ConfigLocationRow.vala"
		g_value_set_string (value, config_location_row_item_get_text (self));
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 15 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_ITEM_SORT_KEY_PROPERTY:
#line 15 "../app/ConfigLocationRow.vala"
		g_value_set_string (value, config_location_row_item_get_sort_key (self));
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 15 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_ITEM_ID_PROPERTY:
#line 15 "../app/ConfigLocationRow.vala"
		g_value_set_string (value, config_location_row_item_get_id (self));
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 15 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_ITEM_PAGE_PROPERTY:
#line 15 "../app/ConfigLocationRow.vala"
		g_value_set_string (value, config_location_row_item_get_page (self));
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 15 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_ITEM_BACKEND_KIND_PROPERTY:
#line 15 "../app/ConfigLocationRow.vala"
		g_value_set_enum (value, config_location_row_item_get_backend_kind (self));
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 2126 "ConfigLocationRow.c"
		default:
#line 15 "../app/ConfigLocationRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 2132 "ConfigLocationRow.c"
	}
}

static void
_vala_config_location_row_item_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	ConfigLocationRowItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONFIG_LOCATION_ROW_TYPE_ITEM, ConfigLocationRowItem);
#line 15 "../app/ConfigLocationRow.vala"
	switch (property_id) {
#line 15 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_ITEM_ICON_PROPERTY:
#line 15 "../app/ConfigLocationRow.vala"
		config_location_row_item_set_icon (self, g_value_get_object (value));
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 15 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_ITEM_TEXT_PROPERTY:
#line 15 "../app/ConfigLocationRow.vala"
		config_location_row_item_set_text (self, g_value_get_string (value));
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 15 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_ITEM_SORT_KEY_PROPERTY:
#line 15 "../app/ConfigLocationRow.vala"
		config_location_row_item_set_sort_key (self, g_value_get_string (value));
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 15 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_ITEM_ID_PROPERTY:
#line 15 "../app/ConfigLocationRow.vala"
		config_location_row_item_set_id (self, g_value_get_string (value));
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 15 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_ITEM_PAGE_PROPERTY:
#line 15 "../app/ConfigLocationRow.vala"
		config_location_row_item_set_page (self, g_value_get_string (value));
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 15 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_ITEM_BACKEND_KIND_PROPERTY:
#line 15 "../app/ConfigLocationRow.vala"
		config_location_row_item_set_backend_kind (self, g_value_get_enum (value));
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 2182 "ConfigLocationRow.c"
		default:
#line 15 "../app/ConfigLocationRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../app/ConfigLocationRow.vala"
		break;
#line 2188 "ConfigLocationRow.c"
	}
}

static GObject *
config_location_row_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ConfigLocationRow * self;
	GListStore* _tmp0_;
	GListStore* _tmp1_;
#line 39 "../app/ConfigLocationRow.vala"
	parent_class = G_OBJECT_CLASS (config_location_row_parent_class);
#line 39 "../app/ConfigLocationRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../app/ConfigLocationRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONFIG_LOCATION_ROW, ConfigLocationRow);
#line 40 "../app/ConfigLocationRow.vala"
	_tmp0_ = g_list_store_new (CONFIG_LOCATION_ROW_TYPE_ITEM);
#line 40 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (self->priv->store);
#line 40 "../app/ConfigLocationRow.vala"
	self->priv->store = _tmp0_;
#line 41 "../app/ConfigLocationRow.vala"
	_tmp1_ = self->priv->store;
#line 41 "../app/ConfigLocationRow.vala"
	adw_combo_row_set_model ((AdwComboRow*) self, (GListModel*) _tmp1_);
#line 39 "../app/ConfigLocationRow.vala"
	return obj;
#line 2220 "ConfigLocationRow.c"
}

static void
config_location_row_class_init (ConfigLocationRowClass * klass,
                                gpointer klass_data)
{
#line 10 "../app/ConfigLocationRow.vala"
	config_location_row_parent_class = g_type_class_peek_parent (klass);
#line 10 "../app/ConfigLocationRow.vala"
	g_type_class_adjust_private_offset (klass, &ConfigLocationRow_private_offset);
#line 10 "../app/ConfigLocationRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_config_location_row_get_property;
#line 10 "../app/ConfigLocationRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_config_location_row_set_property;
#line 10 "../app/ConfigLocationRow.vala"
	G_OBJECT_CLASS (klass)->constructor = config_location_row_constructor;
#line 10 "../app/ConfigLocationRow.vala"
	G_OBJECT_CLASS (klass)->finalize = config_location_row_finalize;
#line 10 "../app/ConfigLocationRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONFIG_LOCATION_ROW_SETTINGS_PROPERTY, config_location_row_properties[CONFIG_LOCATION_ROW_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", DEJA_DUP_TYPE_FILTERED_SETTINGS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../app/ConfigLocationRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONFIG_LOCATION_ROW_DRIVE_SETTINGS_PROPERTY, config_location_row_properties[CONFIG_LOCATION_ROW_DRIVE_SETTINGS_PROPERTY] = g_param_spec_object ("drive-settings", "drive-settings", "drive-settings", DEJA_DUP_TYPE_FILTERED_SETTINGS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../app/ConfigLocationRow.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/DejaDup/ConfigLocationRow.ui");
#line 2245 "ConfigLocationRow.c"
}

static void
config_location_row_instance_init (ConfigLocationRow * self,
                                   gpointer klass)
{
#line 10 "../app/ConfigLocationRow.vala"
	self->priv = config_location_row_get_instance_private (self);
#line 10 "../app/ConfigLocationRow.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2256 "ConfigLocationRow.c"
}

static void
config_location_row_finalize (GObject * obj)
{
	ConfigLocationRow * self;
#line 10 "../app/ConfigLocationRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONFIG_LOCATION_ROW, ConfigLocationRow);
#line 12 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (self->priv->_settings);
#line 13 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (self->priv->_drive_settings);
#line 38 "../app/ConfigLocationRow.vala"
	_g_object_unref0 (self->priv->store);
#line 10 "../app/ConfigLocationRow.vala"
	G_OBJECT_CLASS (config_location_row_parent_class)->finalize (obj);
#line 2273 "ConfigLocationRow.c"
}

 G_GNUC_NO_INLINE static GType
config_location_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConfigLocationRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) config_location_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConfigLocationRow), 0, (GInstanceInitFunc) config_location_row_instance_init, NULL };
	GType config_location_row_type_id;
	config_location_row_type_id = g_type_register_static (adw_combo_row_get_type (), "ConfigLocationRow", &g_define_type_info, 0);
	ConfigLocationRow_private_offset = g_type_add_instance_private (config_location_row_type_id, sizeof (ConfigLocationRowPrivate));
	return config_location_row_type_id;
}

GType
config_location_row_get_type (void)
{
	static gsize config_location_row_type_id__once = 0;
	if (g_once_init_enter (&config_location_row_type_id__once)) {
		GType config_location_row_type_id;
		config_location_row_type_id = config_location_row_get_type_once ();
		g_once_init_leave (&config_location_row_type_id__once, config_location_row_type_id);
	}
	return config_location_row_type_id__once;
}

static void
_vala_config_location_row_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	ConfigLocationRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONFIG_LOCATION_ROW, ConfigLocationRow);
#line 10 "../app/ConfigLocationRow.vala"
	switch (property_id) {
#line 10 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_SETTINGS_PROPERTY:
#line 10 "../app/ConfigLocationRow.vala"
		g_value_set_object (value, config_location_row_get_settings (self));
#line 10 "../app/ConfigLocationRow.vala"
		break;
#line 10 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_DRIVE_SETTINGS_PROPERTY:
#line 10 "../app/ConfigLocationRow.vala"
		g_value_set_object (value, config_location_row_get_drive_settings (self));
#line 10 "../app/ConfigLocationRow.vala"
		break;
#line 2320 "ConfigLocationRow.c"
		default:
#line 10 "../app/ConfigLocationRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../app/ConfigLocationRow.vala"
		break;
#line 2326 "ConfigLocationRow.c"
	}
}

static void
_vala_config_location_row_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	ConfigLocationRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONFIG_LOCATION_ROW, ConfigLocationRow);
#line 10 "../app/ConfigLocationRow.vala"
	switch (property_id) {
#line 10 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_SETTINGS_PROPERTY:
#line 10 "../app/ConfigLocationRow.vala"
		config_location_row_set_settings (self, g_value_get_object (value));
#line 10 "../app/ConfigLocationRow.vala"
		break;
#line 10 "../app/ConfigLocationRow.vala"
		case CONFIG_LOCATION_ROW_DRIVE_SETTINGS_PROPERTY:
#line 10 "../app/ConfigLocationRow.vala"
		config_location_row_set_drive_settings (self, g_value_get_object (value));
#line 10 "../app/ConfigLocationRow.vala"
		break;
#line 2352 "ConfigLocationRow.c"
		default:
#line 10 "../app/ConfigLocationRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../app/ConfigLocationRow.vala"
		break;
#line 2358 "ConfigLocationRow.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

